'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _styles = require('./utils/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Badge = function (_React$Component) {
  _inherits(Badge, _React$Component);

  function Badge(props) {
    _classCallCheck(this, Badge);

    var _this = _possibleConstructorReturn(this, (Badge.__proto__ || Object.getPrototypeOf(Badge)).call(this, props));

    _this.onMouseOver = function () {
      _this.setState({ isHovered: true });
    };

    _this.onMouseLeave = function () {
      _this.setState({ isHovered: false });
    };

    _this.onClear = function (e) {
      e.stopPropagation();
      var _this$props = _this.props,
          onClear = _this$props.onClear,
          value = _this$props.value;

      if (onClear) onClear(value);
    };

    _this.onClick = function () {
      var _this$props2 = _this.props,
          onClick = _this$props2.onClick,
          value = _this$props2.value;

      if (onClick) onClick(value);
    };

    _this.state = { isHovered: false };
    return _this;
  }

  _createClass(Badge, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          text = _props.text,
          style = _props.style,
          isActive = _props.isActive,
          isDisabled = _props.isDisabled,
          canClear = _props.canClear;
      var isHovered = this.state.isHovered;


      var styles = (0, _lodash2.default)({}, Badge.defaultStyles, style);
      var events = { isHovered: isHovered, isActive: isActive, isDisabled: isDisabled };
      (0, _styles.mergeEvents)(styles, events);

      return _react2.default.createElement(
        'span',
        {
          style: styles.base,
          onMouseOver: this.onMouseOver,
          onMouseLeave: this.onMouseLeave,
          onClick: this.onClick
        },
        _react2.default.createElement(
          'p',
          { style: styles.text },
          text
        ),
        canClear ? _react2.default.createElement(
          'i',
          { style: styles.icon,
            className: 'material-icons',
            onClick: this.onClear },
          'clear'
        ) : null
      );
    }
  }]);

  return Badge;
}(_react2.default.Component);

Badge.propTypes = {
  isActive: _propTypes2.default.bool,
  isDisabled: _propTypes2.default.bool,
  value: _propTypes2.default.node,
  text: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]).isRequired,
  icon: _propTypes2.default.node,
  style: _propTypes2.default.object,
  onClear: _propTypes2.default.func,
  canClear: _propTypes2.default.bool
};
Badge.defaultProps = {
  text: '',
  style: {},
  isActive: false,
  isDisabled: false
};
Badge.defaultStyles = {
  base: {
    display: 'inline-flex',
    flex: 'none',
    alignItems: 'center',
    alignSelf: 'flex-start',
    flexWrap: 'nowrap',
    flexGrow: 0,
    flexBasis: 'auto',
    whiteSpace: 'nowrap',
    backgroundColor: '#ffffff',
    color: '#000000',
    borderRadius: 20,
    height: 20,
    width: 'auto',
    padding: '2px 6px',
    margin: 3,
    fontSize: 16,
    fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif',
    verticalAlign: 'middle',
    transition: '500ms'
  },
  hovered: {
    backgroundColor: 'lightgrey',
    cursor: 'default'
  },
  active: {},
  disabled: {},
  text: { margin: 0, padding: 0, display: 'inline-block' },
  icon: { display: 'inline-block', padding: 0, margin: 0, fontSize: 14 }
};
exports.default = Badge;