'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _styles = require('./utils/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button(props) {
    _classCallCheck(this, Button);

    var _this = _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this, props));

    _this.onClick = function (e) {
      var _this$props = _this.props,
          isDisabled = _this$props.isDisabled,
          onClick = _this$props.onClick,
          value = _this$props.value,
          _buttonGroupIndex = _this$props._buttonGroupIndex,
          _buttonGroupClick = _this$props._buttonGroupClick;

      if (isDisabled) return;

      if (onClick) onClick(value, e);
      if (_buttonGroupClick) _buttonGroupClick(value, _buttonGroupIndex, e);

      _this.toggleAria(e.target);
    };

    _this.onChange = function (e) {
      var _this$props2 = _this.props,
          onChange = _this$props2.onChange,
          value = _this$props2.value;

      if (onChange) onChange(value, e);
    };

    _this.onKeyPress = function (e) {
      var _this$props3 = _this.props,
          onClick = _this$props3.onClick,
          onKeyPress = _this$props3.onKeyPress,
          value = _this$props3.value;

      if (e.keyCode === 32 || e.keyCode === 13) {
        var handler = onKeyPress || onClick;
        handler(value);
        _this.toggleAria(e.target);
      }
    };

    _this.onMouseOver = function () {
      if (_this.props.isDisabled) return;
      _this.setState({ isHovered: true });
    };

    _this.onMouseLeave = function () {
      _this.setState({ isHovered: false });
    };

    _this.toggleAria = function (e) {
      var pressed = e.getAttribute("aria-pressed") === "true";
      e.setAttribute("aria-pressed", !pressed);
    };

    _this.onFocus = function (e) {
      var onFocus = _this.props.onFocus;

      if (onFocus) onFocus(e);
    };

    _this.onBlur = function (e) {
      var onBlur = _this.props.onBlur;

      if (onBlur) onBlur(e);
    };

    _this.state = { isHovered: false };
    return _this;
  }

  _createClass(Button, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          text = _props.text,
          style = _props.style,
          tabIndex = _props.tabIndex,
          isActive = _props.isActive,
          isDisabled = _props.isDisabled;
      var isHovered = this.state.isHovered;


      var styles = (0, _lodash2.default)({}, Button.defaultStyles, style);
      var events = { isActive: isActive, isHovered: isHovered, isDisabled: isDisabled };
      (0, _styles.mergeEvents)(styles, events);

      return _react2.default.createElement(
        'button',
        {
          style: styles.base,
          value: value,
          onClick: this.onClick,
          onChange: this.onChange,
          onKeyPress: this.onKeyPress,
          onMouseOver: this.onMouseOver,
          onMouseLeave: this.onMouseLeave,
          onFocus: this.onFocus,
          onBlur: this.onBlur,
          role: 'button',
          'aria-pressed': 'false',
          tabIndex: tabIndex
        },
        text
      );
    }
  }]);

  return Button;
}(_react2.default.Component);

Button.propTypes = {
  text: _propTypes2.default.node,
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool]),
  isDisabled: _propTypes2.default.bool,
  isActive: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  onKeyPress: _propTypes2.default.func,
  style: _propTypes2.default.object,
  tabIndex: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  _buttonGroupClick: _propTypes2.default.func,
  _buttonGroupIndex: _propTypes2.default.number
};
Button.defaultProps = {
  text: 'Button',
  tabIndex: 0,
  isDisabled: false,
  isActive: false,
  style: {}
};
Button.defaultStyles = {
  base: {
    color: '#000000',
    fontSize: 16,
    fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif',
    backgroundColor: '#f9f9f9',
    border: 'none',
    borderRadius: 2,
    padding: 10,
    transition: 'all 0.5s ease',
    outline: 'none',
    cursor: 'pointer',
    boxSizing: 'border-box'
  },
  hovered: {
    backgroundColor: '#E1E1E1'
  },
  disabled: {
    cursor: 'default'
  },
  active: {
    backgroundColor: '#bfbfbf'
  }
};
exports.default = Button;