'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ButtonGroup = function (_React$Component) {
  _inherits(ButtonGroup, _React$Component);

  function ButtonGroup(props) {
    _classCallCheck(this, ButtonGroup);

    var _this = _possibleConstructorReturn(this, (ButtonGroup.__proto__ || Object.getPrototypeOf(ButtonGroup)).call(this, props));

    _this.onChange = function (value) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          activeValue = _this$props.activeValue;


      if (onChange) onChange(value

      // set activeValue externally if specified
      );if (activeValue) return;

      _this.setState({ activeValue: value });
    };

    _this.state = { activeValue: null };
    return _this;
  }

  _createClass(ButtonGroup, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          style = _props.style,
          activeValue = _props.activeValue;


      var styles = (0, _lodash2.default)({}, ButtonGroup.defaultStyles, style);
      var Children = _react2.default.Children.toArray(children).map(function (child, i) {

        var buttonStyles = (0, _lodash2.default)({}, styles.button

        // determine position for style merge
        );var isFirst = i === 0;
        var isLast = i === children.length - 1;
        var isMid = !isFirst && !isLast;

        if (isFirst) (0, _lodash2.default)(buttonStyles.base, buttonStyles.firstButton);
        if (isLast) (0, _lodash2.default)(buttonStyles.base, buttonStyles.lastButton);
        if (isMid) (0, _lodash2.default)(buttonStyles.base, buttonStyles.midButton);

        return _react2.default.cloneElement(child, {
          isActive: child.props.value === activeValue,
          _buttonGroupClick: _this2.onChange,
          _buttonGroupIndex: i,
          style: (0, _lodash2.default)({}, child.props.style, buttonStyles)
        });
      });

      return _react2.default.createElement(
        'div',
        { style: styles.group.base, role: 'group' },
        Children
      );
    }
  }]);

  return ButtonGroup;
}(_react2.default.Component);

ButtonGroup.propTypes = {
  activeValue: _propTypes2.default.number,
  onClick: _propTypes2.default.func,
  style: _propTypes2.default.object
};
ButtonGroup.defaultProps = {
  activeValue: null,
  style: { group: {}, button: {} }
};
ButtonGroup.defaultStyles = {
  group: {
    base: {
      display: 'inline-block'
    }
  },
  button: {
    base: {
      margin: 0
    },
    firstButton: {
      borderRadius: '2px 0 0 2px',
      borderRight: '1px solid #bfbfbf'
    },
    midButton: {
      borderRadius: 0,
      borderRight: '1px solid #bfbfbf'
    },
    lastButton: {
      borderRadius: '0 2px 2px 0'
    }
  }

};
exports.default = ButtonGroup;