'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _styles = require('./utils/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Checkbox = function (_React$Component) {
  _inherits(Checkbox, _React$Component);

  function Checkbox(props) {
    _classCallCheck(this, Checkbox);

    var _this = _possibleConstructorReturn(this, (Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).call(this, props));

    _initialiseProps.call(_this);

    _this.state = { isChecked: false, isHovered: false };
    return _this;
  }

  _createClass(Checkbox, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          isDisabled = _props.isDisabled,
          isPartialCheck = _props.isPartialCheck,
          value = _props.value,
          id = _props.id,
          tabIndex = _props.tabIndex,
          name = _props.name,
          style = _props.style;
      var isHovered = this.state.isHovered;


      var styles = (0, _lodash2.default)({}, Checkbox.defaultStyles, style, { checkbox: { base: { fontSize: this.props.size } } });
      if (this.isChecked) (0, _lodash2.default)(styles.checkbox.base, styles.checkbox.checked);

      var events = { isDisabled: isDisabled, isHovered: isHovered };
      (0, _styles.mergeEvents)(styles.checkbox, events);

      return _react2.default.createElement(
        'span',
        { style: styles.container.base },
        _react2.default.createElement('input', {
          style: styles.input.base,
          id: id,
          type: 'checkbox',
          role: 'checkbox',
          name: name,
          value: value,
          'aria-checked': this.isChecked,
          'aria-disabled': isDisabled,
          tabIndex: tabIndex,
          checked: this.isChecked,
          disabled: isDisabled,
          onChange: function onChange() {},
          onMouseOver: this.onMouseOver,
          onMouseLeave: this.onMouseLeave
        }),
        _react2.default.createElement(
          'i',
          { style: styles.checkbox.base,
            className: 'material-icons',
            role: 'checkbox',
            'aria-checked': this.isChecked,
            'aria-disabled': isDisabled,
            onClick: this.onClick },
          ' ',
          !isPartialCheck ? 'check' : 'remove'
        )
      );
    }
  }, {
    key: 'isChecked',
    get: function get() {
      var isChecked = this.props.isChecked;

      var checkedProp = isChecked || isChecked === false;
      return checkedProp ? isChecked : this.state.isChecked;
    }
  }]);

  return Checkbox;
}(_react2.default.Component);

Checkbox.propTypes = {
  isChecked: function isChecked(props, propName, componentName) {
    var exists = props[propName] || props[propName] === false;

    // if(exists && !props.onClick)
    //   return new Error(`${propName} -  By providing ${propName} to ${componentName}, the onClick prop must be handled.`)

    // if(props.onClick && !exists)
    //   return new Error(`${propName} -  By providing onClick to ${componentName}, the ${propName} prop must be handled.`)

    if (exists && typeof props[propName] !== 'boolean') {
      return new Error('Invalid prop `' + propName + '` supplied to' + ' `' + componentName + '`. Validation failed. Expected a boolean value.');
    }
  },
  isPartialCheck: _propTypes2.default.bool,
  size: _propTypes2.default.number,
  isDisabled: _propTypes2.default.bool,
  name: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  id: _propTypes2.default.string,
  tabIndex: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  value: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.string, _propTypes2.default.number]),
  onClick: _propTypes2.default.func,
  style: _propTypes2.default.object
};
Checkbox.defaultProps = {
  id: null,
  name: null,
  value: '',
  tabIndex: 0,
  isDisabled: false,
  style: {},
  size: 18,
  isPartialCheck: false
};
Checkbox.defaultStyles = {
  container: {
    base: { position: 'block' }
  },
  input: {
    base: {
      position: 'absolute',
      height: 0,
      opacity: 0,
      overflow: 'hidden',
      width: 0
    }
  },
  checkbox: {
    base: {
      backgroundColor: 'white',
      borderRadius: 2,
      border: '1px solid black',
      color: 'white',
      padding: 0,
      cursor: 'default',
      MozUserSelect: 'none',
      WebkitUserSelect: 'none',
      MsUserSelect: 'none',
      userSelect: 'none',
      boxSizing: 'border-box',
      margin: 3
    },
    hovered: {},
    disabled: {
      backgroundColor: 'grey'
    },
    checked: {
      backgroundColor: 'white',
      color: 'black'
    }
  }
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.onClick = function (e) {
    var _props2 = _this2.props,
        isDisabled = _props2.isDisabled,
        onClick = _props2.onClick,
        value = _props2.value;

    if (isDisabled) return;

    if (onClick) onClick(!_this2.isChecked, value, e);

    if (_this2.props.isChecked) return;
    _this2.setState({ isChecked: !_this2.isChecked });
  };

  this.onMouseOver = function () {
    _this2.setState({
      isHovered: true
    });
  };

  this.onMouseLeave = function () {
    _this2.setState({
      isHovered: false
    });
  };
};

exports.default = Checkbox;