'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown(props) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props));

    _initialiseProps.call(_this);

    _this.state = { isActive: false };
    return _this;
  }

  _createClass(Dropdown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('click', this.onClickOutside, false);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.onClickOutside, false);
    }
  }, {
    key: 'cloneWithProps',
    value: function cloneWithProps(child) {
      // map the private on click from children up to this parent
      return _react2.default.cloneElement(child, {
        _onClick: this.onClick,
        isActive: child.props.isActive || this.isActive
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          children = _props.children;


      var styles = (0, _lodash2.default)({}, Dropdown.defaultStyles, style);

      return _react2.default.createElement(
        'span',
        { role: 'dropdown',
          ref: function ref(main) {
            return _this2.main = main;
          }, style: styles.base },
        _react2.default.Children.toArray(children).map(function (child) {
          return _this2.cloneWithProps(child);
        })
      );
    }
  }, {
    key: 'isActive',
    get: function get() {
      var isActive = this.props.isActive;

      var activeProp = isActive || isActive === false;
      return activeProp ? isActive : this.state.isActive;
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

Dropdown.propTypes = {
  style: _propTypes2.default.object,
  onClick: _propTypes2.default.func,
  onClickOutside: _propTypes2.default.func,
  isActive: function isActive(props, propName, componentName) {
    var exists = props[propName] || props[propName] === false;

    if (props.onClickOutside && !exists) return new Error(propName + ' -  By providing onClickOutside to ' + componentName + ', the ' + propName + ' prop must be handled.');

    if (exists && typeof props[propName] !== 'boolean') {
      return new Error('Invalid prop `' + propName + '` supplied to' + ' `' + componentName + '`. Validation failed. Expected a boolean value.');
    }
  }
};
Dropdown.defaultProps = {
  style: {}
};
Dropdown.defaultStyles = {
  base: {
    display: 'inline-block',
    position: 'relative'
  }
};

var _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.onClick = function () {
    var onClick = _this3.props.onClick;

    var isActive = _this3.isActive;

    if (onClick) return onClick();
    _this3.setState({ isActive: !isActive });
  };

  this.onClickOutside = function (e) {
    var onClickOutside = _this3.props.onClickOutside;

    var isActive = _this3.isActive;

    // if clicking inside the component, return
    if (_this3.main && _this3.main.contains(e.target)) return;

    // if method is specified, return the method
    if (onClickOutside && isActive) return onClickOutside

    // otherwise set the state to inactive
    ();if (isActive) _this3.setState({ isActive: false });
  };
};

exports.default = Dropdown;