'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _styles = require('./utils/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DropdownMenu = function (_React$Component) {
  _inherits(DropdownMenu, _React$Component);

  function DropdownMenu(props) {
    _classCallCheck(this, DropdownMenu);

    var _this = _possibleConstructorReturn(this, (DropdownMenu.__proto__ || Object.getPrototypeOf(DropdownMenu)).call(this, props));

    _this.onClick = function () {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          _onClick = _this$props._onClick;

      if (onClick) onClick();
      _onClick //private on click
      ();
    };

    _this.state = { height: null };
    return _this;
  }

  _createClass(DropdownMenu, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.drop === 'up') {
        var element = _reactDom2.default.findDOMNode(this.ref);
        var height = window.getComputedStyle(element).height;
        this.setState({ height: parseInt(height, 10) });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          justify = _props.justify,
          drop = _props.drop,
          offset = _props.offset,
          isActive = _props.isActive;


      var styles = (0, _lodash2.default)({}, DropdownMenu.defaultStyles, style);
      if (justify === 'right') (0, _lodash2.default)(styles.base, styles.right);
      if (justify === 'left') (0, _lodash2.default)(styles.base, styles.left);

      if (drop === 'up') (0, _lodash2.default)(styles.base, { bottom: this.state.height - offset || 0 });

      var events = { isActive: isActive };
      (0, _styles.mergeEvents)(styles, events);

      return _react2.default.createElement(
        'div',
        {
          role: 'menu',
          ref: function ref(_ref) {
            return _this2.ref = _ref;
          },
          style: styles.base,
          onClick: this.onClick
        },
        this.props.children
      );
    }
  }]);

  return DropdownMenu;
}(_react2.default.Component);

DropdownMenu.propTypes = {
  onClick: _propTypes2.default.func,
  _onClick: _propTypes2.default.func, //private
  justify: _propTypes2.default.oneOf(['left', 'right']),
  drop: _propTypes2.default.oneOf(['up', 'down']),
  offset: _propTypes2.default.number,
  isActive: _propTypes2.default.bool,
  style: _propTypes2.default.object
};
DropdownMenu.defaultProps = {
  justify: 'left',
  drop: 'down',
  offset: 0,
  style: {}
};
DropdownMenu.defaultStyles = {
  base: {
    position: 'absolute',
    width: 'auto',
    minWidth: 200,
    visibility: 'hidden',
    opacity: 0,
    backgroundColor: 'white',
    marginTop: 3,
    borderRadius: 2,
    zIndex: 10000,
    transition: '0.5s ease'
  },
  right: { right: 0 },
  left: { left: 0 },
  active: {
    visibility: 'visible',
    opacity: 1
  },
  hovered: {},
  disabled: {}
};
exports.default = DropdownMenu;