'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _styles = require('./utils/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DropdownNode = function (_React$Component) {
  _inherits(DropdownNode, _React$Component);

  function DropdownNode(props) {
    _classCallCheck(this, DropdownNode);

    var _this = _possibleConstructorReturn(this, (DropdownNode.__proto__ || Object.getPrototypeOf(DropdownNode)).call(this, props));

    _this.onClick = function () {
      var _this$props = _this.props,
          isDisabled = _this$props.isDisabled,
          onClick = _this$props.onClick,
          _onClick = _this$props._onClick;

      if (isDisabled) return;
      if (onClick) onClick();
      _onClick // private on click
      ();
    };

    _this.onMouseOver = function () {
      _this.setState({ isHovered: true });
    };

    _this.onMouseLeave = function () {
      _this.setState({ isHovered: false });
    };

    _this.state = { isHovered: false };
    return _this;
  }

  _createClass(DropdownNode, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          isDisabled = _props.isDisabled,
          isActive = _props.isActive,
          style = _props.style;
      var isHovered = this.state.isHovered;


      var styles = (0, _lodash2.default)({}, DropdownNode.defaultStyles, style);

      var events = { isActive: isActive, isDisabled: isDisabled, isHovered: isHovered };
      (0, _styles.mergeEvents)(styles, events);

      return _react2.default.createElement(
        'div',
        {
          style: styles.base,
          onMouseOver: this.onMouseOver,
          onMouseLeave: this.onMouseLeave,
          onClick: this.onClick },
        this.props.children
      );
    }
  }]);

  return DropdownNode;
}(_react2.default.Component);

DropdownNode.propTypes = {
  onClick: _propTypes2.default.func,
  _onClick: _propTypes2.default.func, //private
  isDisabled: _propTypes2.default.bool,
  isActive: _propTypes2.default.bool,
  style: _propTypes2.default.object
};
DropdownNode.defaultProps = {
  style: {}
};
DropdownNode.defaultStyles = {
  base: {
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    boxSizing: 'border-box',
    height: '100%',
    color: '#000000',
    fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif',
    fontSize: 16,
    backgroundColor: '#ffffff',
    border: 'none',
    borderRadius: 2,
    cursor: 'default',
    padding: 10,
    transition: 'all 0.5s ease'
  },
  active: {
    cursor: 'pointer'
  },
  hovered: {
    cursor: 'pointer'
  },
  disabled: {
    cursor: 'default'
  }
};
exports.default = DropdownNode;