'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _styles = require('./utils/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DropdownOption = function (_React$Component) {
  _inherits(DropdownOption, _React$Component);

  function DropdownOption(props) {
    _classCallCheck(this, DropdownOption);

    var _this = _possibleConstructorReturn(this, (DropdownOption.__proto__ || Object.getPrototypeOf(DropdownOption)).call(this, props));

    _this.onMouseOver = function () {
      _this.setState({
        isHovered: true
      });
    };

    _this.onMouseLeave = function () {
      _this.setState({
        isHovered: false
      });
    };

    _this.onClick = function () {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          isDisabled = _this$props.isDisabled,
          value = _this$props.value;

      if (isDisabled) return;
      if (onClick) onClick(value);
    };

    _this.state = { isHovered: false };
    return _this;
  }

  _createClass(DropdownOption, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          isActive = _props.isActive,
          isDisabled = _props.isDisabled,
          text = _props.text;
      var isHovered = this.state.isHovered;


      var styles = (0, _lodash2.default)({}, DropdownOption.defaultStyles, style);
      if (this.isLast) (0, _lodash2.default)(styles.base, styles.last);

      var events = { isActive: isActive, isDisabled: isDisabled, isHovered: isHovered };
      (0, _styles.mergeEvents)(styles, events);

      return _react2.default.createElement(
        'div',
        {
          role: 'menuitem',
          ref: function ref(node) {
            return _this2.node = node;
          },
          style: styles.base,
          onMouseOver: this.onMouseOver,
          onMouseLeave: this.onMouseLeave,
          onClick: this.onClick
        },
        text
      );
    }
  }, {
    key: 'isLast',
    get: function get() {
      if (!this.node) return;

      var lastChild = this.node.parentNode.lastChild;
      return lastChild === this.node;
    }
  }]);

  return DropdownOption;
}(_react2.default.Component);

DropdownOption.propTypes = {
  text: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.node]).isRequired,
  isDisabled: _propTypes2.default.bool,
  isActive: _propTypes2.default.bool,
  onClick: _propTypes2.default.func.isRequired,
  style: _propTypes2.default.object
};
DropdownOption.defaultProps = {
  shouldHideMenu: true,
  style: {}
};
DropdownOption.defaultStyles = {
  base: {
    padding: 10,
    fontSize: 16,
    cursor: 'default',
    transition: '0.2s all',
    backgroundColor: '#ffffff',
    borderBottom: '1px solid #dcdcdc'
  },
  last: {
    borderBottom: null
  },
  active: {
    backgroundColor: '#f9f9f9',
    cursor: 'pointer'
  },
  hovered: {
    backgroundColor: '#f9f9f9',
    cursor: 'pointer'
  },
  disabled: {
    backgroundColor: '#dcdcdc',
    cursor: 'default'
  }
};
exports.default = DropdownOption;