'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HiddenPanel = function (_React$Component) {
  _inherits(HiddenPanel, _React$Component);

  function HiddenPanel() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, HiddenPanel);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = HiddenPanel.__proto__ || Object.getPrototypeOf(HiddenPanel)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function () {
      if (_this.props.onClick) _this.props.onClick();
    }, _this.onClickOutside = function (e) {
      var onClickOutside = _this.props.onClickOutside;

      if (!_this.props.isVisible) return;
      if (_this.ref && _this.ref.contains(e.target)) return;

      if (onClickOutside) onClickOutside(e);
    }, _this.calculateHeightOffset = function () {
      _this.setState({ length: window.innerHeight - _this.props.offSet });
    }, _this.setVisibility = function (styles) {
      var _this$props = _this.props,
          position = _this$props.position,
          isVisible = _this$props.isVisible,
          width = _this$props.width;

      styles.panel[position] = isVisible ? 0 : -width;
      return styles;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(HiddenPanel, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('resize', this.calculateHeightOffset, false);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.calculateHeightOffset, false);
      document.removeEventListener('click', this.onClickOutside, false);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.isVisible) {
        document.addEventListener('click', this.onClickOutside, false);
      }

      if (nextProps.isVisible === false) {
        document.removeEventListener('click', this.onClickOutside, false);
      }
    }

    //TODO: Address possible bubbling bug

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          position = _props.position,
          isVisible = _props.isVisible,
          style = _props.style,
          children = _props.children;


      var styles = (0, _lodash2.default)({}, HiddenPanel.defaultStyles, style);
      (0, _lodash2.default)(styles.panel.base, styles.panel[position], _defineProperty({}, position, isVisible ? 0 : -styles.panel.base.width));

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          {
            ref: function ref(_ref2) {
              return _this2.ref = _ref2;
            },
            style: styles.panel.base
          },
          children
        ),
        isVisible ? _react2.default.createElement('div', { style: styles.overlay }) : null
      );
    }
  }]);

  return HiddenPanel;
}(_react2.default.Component);

HiddenPanel.propTypes = {
  isVisible: _propTypes2.default.bool,
  position: _propTypes2.default.oneOf(['left', 'right']),
  style: _propTypes2.default.object,
  onClickOutside: _propTypes2.default.func,
  onClick: _propTypes2.default.func
};
HiddenPanel.defaultProps = {
  isVisible: false,
  position: 'left',
  style: {}
};
HiddenPanel.defaultStyles = {
  panel: {
    base: {
      top: 0,
      backgroundColor: 'white',
      width: 300,
      height: '100vh',
      position: 'fixed',
      zIndex: 1000000,
      transition: 'all 500ms ease-in-out',
      boxSizing: 'border-box'
    },
    left: { left: 0 },
    right: { right: 0 }
  },
  overlay: {
    position: 'fixed',
    left: 0,
    right: 0,
    top: 0,
    bottom: 0,
    zIndex: 999999,
    backgroundColor: 'rgba(0,0,0,0.5)',
    transition: 'all 500ms ease-in-out'
  }
};
exports.default = HiddenPanel;