'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./utils/styles');

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Modal = function (_React$Component) {
  _inherits(Modal, _React$Component);

  function Modal() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Modal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Modal.__proto__ || Object.getPrototypeOf(Modal)).call.apply(_ref, [this].concat(args))), _this), _this.onClickOutside = function (e) {
      var onClickOutside = _this.props.onClickOutside;

      if (_this.ref && _this.ref.contains(e.target)) return;
      if (!_this.props.isVisible) return;

      if (onClickOutside) onClickOutside();
    }, _this.center = function () {
      if (!_this.ref) return {};
      var width = (0, _styles.getComputedStyleProp)(_this.ref, 'width');
      var marginLeft = -(width / 2);
      return { width: width, marginLeft: marginLeft, left: '50%' };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Modal, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.onClickOutside, false);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.isVisible) {
        document.addEventListener('click', this.onClickOutside, false);
      }

      if (nextProps.isVisible === false) {
        document.removeEventListener('click', this.onClickOutside, false);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          isVisible = _props.isVisible,
          style = _props.style,
          children = _props.children;


      var styles = (0, _lodash2.default)({}, Modal.defaultStyles, style);
      if (isVisible) {
        (0, _lodash2.default)(styles.base, styles.isVisible);
        (0, _lodash2.default)(styles.overlay.base, styles.overlay.isVisible);
      }

      return _react2.default.createElement(
        'div',
        { ref: function ref(_ref2) {
            return _this2.ref = _ref2;
          }, style: styles.base },
        this.props.showOverlay ? _react2.default.createElement('div', { style: styles.overlay.base }) : null,
        children
      );
    }
  }]);

  return Modal;
}(_react2.default.Component);

Modal.propTypes = {
  isVisible: _propTypes2.default.bool.isRequired,
  children: _propTypes2.default.element.isRequired,
  onClickOutside: _propTypes2.default.func,
  showOverlay: _propTypes2.default.bool,
  style: _propTypes2.default.object
};
Modal.defaultProps = {
  isVisible: false,
  showOverlay: true,
  style: {}
};
Modal.defaultStyles = {
  base: {
    position: 'fixed',
    visibility: 'hidden',
    opacity: '0',
    top: 0,
    transition: 'visibility 500ms, opacity 500ms, top 500ms',
    zIndex: 2
  },
  isVisible: {
    visibility: 'visible',
    opacity: 1,
    top: 100
  },
  overlay: {
    base: {
      position: 'fixed',
      top: 0,
      bottom: 0,
      left: 0,
      right: 0,
      visibility: 'hidden',
      backgroundColor: '#000000',
      opacity: 0,
      transition: 'visibility 500ms, opacity 500ms'
    },
    isVisible: {
      visibility: 'visible',
      opacity: 0.5
    }
  }
};
exports.default = Modal;