'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Navbar = function (_React$Component) {
  _inherits(Navbar, _React$Component);

  function Navbar(props) {
    _classCallCheck(this, Navbar);

    var _this = _possibleConstructorReturn(this, (Navbar.__proto__ || Object.getPrototypeOf(Navbar)).call(this, props));

    _this.calculateLinkWidth = function () {
      var leftWidth = parseInt(window.getComputedStyle(_this.leftLinks).width) || 0;
      var rightWidth = parseInt(window.getComputedStyle(_this.rightLinks).width) || 0;
      return leftWidth + rightWidth;
    };

    _this.updateIsMobile = function () {
      var isMobile = !_this.mediaQuery.matches;
      _this.setState({ isMobile: isMobile, isMenuVisible: false });
    };

    _this.toggleMobileMenu = function () {
      _this.setState({
        isMenuVisible: !_this.state.isMenuVisible
      });
    };

    _this.handleMenuClick = function () {
      _this.setState({ isMenuVisible: false });
    };

    _this.state = { isMobile: false, isMenuVisible: false };
    return _this;
  }

  _createClass(Navbar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var responsiveWidth = this.props.responsiveWidth;


      var minWidth = responsiveWidth === 'auto' ? this.calculateLinkWidth() : responsiveWidth;

      this.mediaQuery = window.matchMedia('(min-width: ' + minWidth + 'px)');
      this.mediaQuery.addListener(this.updateIsMobile);
      this.updateIsMobile();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.mediaQuery.removeListener(this.updateIsMobile);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          style = _props.style,
          children = _props.children;
      var _state = this.state,
          isMobile = _state.isMobile,
          isMenuVisible = _state.isMenuVisible;


      var styles = (0, _lodash2.default)({}, Navbar.defaultStyles, style);
      if (isMenuVisible) (0, _lodash2.default)(styles.menu.base, styles.menu.isVisible);

      return _react2.default.createElement(
        'div',
        { style: styles.base },
        isMobile ? this.renderMobile(children, styles) : this.renderDesktop(children, styles)
      );
    }
  }, {
    key: 'renderDesktop',
    value: function renderDesktop(children, styles) {
      var _this2 = this;

      var links = _react2.default.Children.toArray(children).reduce(function (obj, link) {
        var append = link.props.append;

        obj[append || 'left'].push(_react2.default.cloneElement(link, { isMobile: false }));
        return obj;
      }, { left: [], right: [] });

      return _react2.default.createElement(
        'div',
        { style: styles.bar },
        _react2.default.createElement(
          'ul',
          { ref: function ref(ul) {
              return _this2.leftLinks = ul;
            }, style: styles.linkContainer },
          links.left
        ),
        _react2.default.createElement(
          'ul',
          { ref: function ref(ul) {
              return _this2.rightLinks = ul;
            }, style: styles.linkContainer },
          links.right
        )
      );
    }
  }, {
    key: 'renderMobile',
    value: function renderMobile(children, styles) {
      var _this3 = this;

      var links = _react2.default.Children.toArray(children).reduce(function (obj, link) {
        var appendResponsive = link.props.appendResponsive;

        obj[appendResponsive || 'menu'].push(_react2.default.cloneElement(link, { isMobile: appendResponsive !== 'bar' }));
        return obj;
      }, { bar: [], menu: [] });

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'nav',
          { role: 'navigation', style: styles.bar },
          _react2.default.createElement(
            'ul',
            { style: styles.linkContainer },
            links.bar
          ),
          _react2.default.createElement(
            'i',
            { className: 'material-icons',
              onClick: this.toggleMobileMenu,
              style: styles.menuButton },
            'menu'
          )
        ),
        _react2.default.createElement(
          'ul',
          {
            ref: function ref(ul) {
              return _this3.menu = ul;
            },
            style: styles.menu.base,
            onClick: this.handleMenuClick
          },
          links.menu
        )
      );
    }
  }]);

  return Navbar;
}(_react2.default.Component);

Navbar.propTypes = {
  style: _propTypes2.default.object,
  responsiveWidth: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  menuIcon: _propTypes2.default.node,
  appendMenuButton: _propTypes2.default.oneOf(['left', 'right'])
};
Navbar.defaultProps = {
  style: {},
  responsiveWidth: 'auto',
  appendMenuButton: 'right'
};
Navbar.defaultStyles = {
  base: {
    position: 'relative',
    width: '100%',
    zIndex: 9999
  },
  bar: {
    display: 'flex',
    justifyContent: 'space-between',
    alignItems: 'center',
    width: '100%',
    height: 70,
    backgroundColor: '#1B1B1B',
    top: 0,
    left: 0
  },
  linkContainer: {
    display: 'flex',
    alignItems: 'center',
    padding: 0,
    margin: 0,
    height: '100%',
    listStyleType: 'none'
  },
  menuButton: {
    margin: '0 15px',
    padding: '5px 10px'
  },
  menu: {
    base: {
      position: 'absolute',
      width: '100%',
      backgroundColor: '#525252',
      margin: 0,
      paddingLeft: 0,
      visibility: 'hidden',
      overflowY: 'hidden',
      //transition: 'all 0.7s ease-in-out',
      boxShadow: '0px 2px 4px 0px rgba(0,0,0, 0.35)'
    },
    isVisible: {
      visibility: 'visible'
    }
  }
};
exports.default = Navbar;