'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.isfunction');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NavbarLink = function (_React$Component) {
  _inherits(NavbarLink, _React$Component);

  function NavbarLink(props) {
    _classCallCheck(this, NavbarLink);

    var _this = _possibleConstructorReturn(this, (NavbarLink.__proto__ || Object.getPrototypeOf(NavbarLink)).call(this, props));

    _this.handleHover = function () {
      var onHover = _this.props.onHover;

      var isHovered = !_this.state.isHovered;

      if (onHover) onHover(isHovered);
      _this.setState({ isHovered: isHovered });
    };

    _this.setLinkColor = function (styles) {
      var _this$props = _this.props,
          isActive = _this$props.isActive,
          isMobile = _this$props.isMobile;
      var isHovered = _this.state.isHovered;


      if (isMobile) {
        if (isActive) (0, _lodash2.default)(styles.menuLink.base, styles.menuLink.active);
        if (isHovered) (0, _lodash2.default)(styles.menuLink.base, styles.menuLink.hover);
      } else {
        if (isActive) (0, _lodash2.default)(styles.link.base, styles.link.active);
        if (isHovered) (0, _lodash2.default)(styles.link.base, styles.link.hover);
      }

      return styles;
    };

    _this.renderLinkType = function (styles) {
      var _this$props2 = _this.props,
          children = _this$props2.children,
          to = _this$props2.to,
          isMobile = _this$props2.isMobile;

      var linkStyle = isMobile ? styles.menuLink.base : styles.link.base;

      if (typeof to === 'string') return _react2.default.createElement(
        'a',
        {
          style: linkStyle,
          href: to
        },
        children
      );

      if ((0, _lodash4.default)(to)) return _react2.default.createElement(
        'a',
        {
          style: linkStyle,
          onClick: to
        },
        children
      );

      return _react2.default.createElement(
        'div',
        { style: linkStyle },
        children
      );
    };

    _this.state = { isHovered: false };
    return _this;
  }

  _createClass(NavbarLink, [{
    key: 'render',
    value: function render() {
      var style = this.props.style;


      var styles = (0, _lodash2.default)({}, NavbarLink.defaultStyles, style);
      this.setLinkColor(styles);

      return _react2.default.createElement(
        'li',
        {
          style: styles.base,
          onMouseOver: this.handleHover,
          onMouseLeave: this.handleHover
        },
        this.renderLinkType(styles)
      );
    }
  }]);

  return NavbarLink;
}(_react2.default.Component);

NavbarLink.propTypes = {
  append: _propTypes2.default.oneOf(['left', 'right']),
  appendResponsive: _propTypes2.default.oneOf(['bar', 'menu', 'hide']),
  to: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]),
  isActive: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  onHover: _propTypes2.default.func
};
NavbarLink.defaultProps = {
  append: 'left',
  appendResponsive: 'menu',
  isActive: false,
  style: {}
};
NavbarLink.defaultStyles = {
  base: {
    height: '100%',
    display: 'inline',
    padding: 0
  },
  link: {
    base: {
      display: 'flex',
      alignItems: 'center',
      height: '100%',
      margin: 0,
      padding: '0 15px',
      fontSize: 16,
      fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif',
      textDecoration: 'none',
      color: 'white',
      cursor: 'pointer'
    },
    active: {
      backgroundColor: '#323232'
    },
    hover: {
      backgroundColor: '#979797'
    }
  },
  menuLink: {
    base: {
      display: 'flex',
      alignItems: 'center',
      borderBottom: '1px solid #282828',
      height: '100%',
      margin: 0,
      padding: '20px 15px',
      fontSize: 16,
      fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif',
      textDecoration: 'none',
      color: 'white',
      cursor: 'pointer'
    },
    active: {
      backgroundColor: '#cecece'
    },
    hover: {
      backgroundColor: '#cecece'
    }
  }
};
exports.default = NavbarLink;