'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _array = require('./utils/array');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Permission = {
  GRANTED: 'granted',
  DENIED: 'denied',
  DEFAULT: 'default'
};

var NotificationCenter = function (_React$Component) {
  _inherits(NotificationCenter, _React$Component);

  function NotificationCenter(props) {
    _classCallCheck(this, NotificationCenter);

    var _this = _possibleConstructorReturn(this, (NotificationCenter.__proto__ || Object.getPrototypeOf(NotificationCenter)).call(this, props));

    _this.notify = function (notification) {
      if (!window.Notification) return;
      if (Notification.permission !== Permission.GRANTED) return;

      var n = new Notification(notification.title, _extends({}, notification));

      var _this$props = _this.props,
          onClick = _this$props.onClick,
          onClose = _this$props.onClose,
          onError = _this$props.onError;


      n.onclick = function (e) {
        e.preventDefault();
        if (onClick) onClick(e);
      };

      n.onclose = function (e) {
        if (onClose) onClose(e);
      };

      n.onerror = function (e) {
        if (onError) onError(e);
      };

      if (notification.timeout) setTimeout(n.close.bind(n), notification.timeout);
    };

    _this.state = { queue: [] };
    return _this;
  }

  _createClass(NotificationCenter, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.requestPermission();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var notifications = (0, _array.findAdditions)(prevProps.notifications, this.props.notifications);
      notifications.forEach(this.notify);
    }
  }, {
    key: 'requestPermission',
    value: function requestPermission() {
      if (!window.Notification) return;
      if (Notification.permission === Permission.GRANTED) return;
      if (Notification.permission === Permission.DENIED) return;

      Notification.requestPermission().then(function (permission) {
        if (permission === "granted") {
          //this.notify()
        }
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return NotificationCenter;
}(_react2.default.Component);

NotificationCenter.propTypes = {
  notifications: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    title: _propTypes2.default.string,
    body: _propTypes2.default.string,
    icon: _propTypes2.default.string,
    image: _propTypes2.default.string,
    badge: _propTypes2.default.string,
    dir: _propTypes2.default.string,
    lang: _propTypes2.default.string,
    tag: _propTypes2.default.string,
    timeout: _propTypes2.default.number,
    data: _propTypes2.default.node,
    vibrate: _propTypes2.default.node,
    renotify: _propTypes2.default.bool,
    requireInteraction: _propTypes2.default.bool
  })),
  onClose: _propTypes2.default.func,
  onClick: _propTypes2.default.func,
  onError: _propTypes2.default.func
};
exports.default = NotificationCenter;