'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ProgressBar = function (_React$Component) {
  _inherits(ProgressBar, _React$Component);

  function ProgressBar(props) {
    _classCallCheck(this, ProgressBar);

    var _this = _possibleConstructorReturn(this, (ProgressBar.__proto__ || Object.getPrototypeOf(ProgressBar)).call(this, props));

    _this.getPercentageComplete = function (completed, outOf) {

      var percentageComplete = Math.floor(completed / outOf * 100);

      if (percentageComplete > 100) percentageComplete = 100;

      return percentageComplete;
    };

    _this.state = { percentageComplete: 0 };
    return _this;
  }

  _createClass(ProgressBar, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          completed = _props.completed,
          outOf = _props.outOf;

      this.setState({
        percentageComplete: this.getPercentageComplete(completed, outOf)
      });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _props2 = this.props,
          completed = _props2.completed,
          outOf = _props2.outOf;


      if (nextProps.outOf !== outOf || nextProps.completed !== completed) {
        this.setState({
          percentageComplete: this.getPercentageComplete(nextProps.completed, nextProps.outOf)
        });
      }
    }
  }, {
    key: 'renderUnits',
    value: function renderUnits(styles) {
      var _props3 = this.props,
          showUnits = _props3.showUnits,
          units = _props3.units,
          completed = _props3.completed,
          outOf = _props3.outOf;
      var percentageComplete = this.state.percentageComplete;


      if (!showUnits) return;

      var display = units === 'number' ? completed + ' of ' + outOf : percentageComplete + '%';

      return _react2.default.createElement(
        'p',
        { className: 'units', style: styles.units },
        display
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props,
          style = _props4.style,
          type = _props4.type;
      var percentageComplete = this.state.percentageComplete;


      var styles = (0, _lodash2.default)({}, ProgressBar.defaultStyles, style);

      if (type === 'progress') {
        (0, _lodash2.default)(styles.bar, styles.progressBar);
        (0, _lodash2.default)(styles.completed, styles.progressCompleted, { width: percentageComplete + '%' });
      }

      if (type === 'heat') {
        (0, _lodash2.default)(styles.bar, styles.heatBar);
        (0, _lodash2.default)(styles.completed, styles.heatCompleted, { width: percentageComplete + '%' });
      }

      return _react2.default.createElement(
        'div',
        { style: styles.base },
        this.renderUnits(styles),
        _react2.default.createElement(
          'div',
          { style: styles.bar },
          _react2.default.createElement('div', { style: styles.completed })
        )
      );
    }
  }]);

  return ProgressBar;
}(_react2.default.Component);

ProgressBar.propTypes = {
  completed: _propTypes2.default.number.isRequired,
  outOf: _propTypes2.default.number.isRequired,
  showUnits: _propTypes2.default.bool,
  units: _propTypes2.default.oneOf(['percent', 'number']),
  type: _propTypes2.default.oneOf(['heat', 'progress']),
  style: _propTypes2.default.object
};
ProgressBar.defaultProps = {
  completed: 0,
  outOf: 0,
  showUnits: false,
  units: 'percent',
  type: 'progress',
  style: {}
};
ProgressBar.defaultStyles = {
  base: {
    width: '100%'
  },
  units: {
    width: '100%',
    textAlign: 'right',
    margin: 0,
    padding: 0,
    fontSize: 16,
    fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif'
  },
  bar: {},
  completed: {},
  progressBar: {
    height: 26,
    padding: 0,
    backgroundColor: '#FF0000',
    overflow: 'hidden',
    borderRadius: 3
  },
  progressCompleted: {
    height: '100%',
    width: '0%', //percentageComplete
    background: 'linear-gradient( to top right, #008000, #00C000)',
    transition: 'width 1s'
  },
  heatBar: {
    height: 26,
    padding: 0,
    background: 'linear-gradient(to left, #27ae60 0%,#dfea10 40%,#efec13 60%,#e74c3c 100%)',
    overflow: 'hidden',
    borderRadius: 3
  },
  heatCompleted: {
    height: '100%',
    width: '0%', //percentageComplete
    borderRight: '2px solid black',
    transition: 'width 1s'
  }
};
exports.default = ProgressBar;