'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SearchBar = function (_React$Component) {
  _inherits(SearchBar, _React$Component);

  function SearchBar(props) {
    _classCallCheck(this, SearchBar);

    var _this = _possibleConstructorReturn(this, (SearchBar.__proto__ || Object.getPrototypeOf(SearchBar)).call(this, props));

    _this.onClickOutside = function (e) {
      if (_this.node && _this.node.contains(e.target)) return;

      _this.node.style.outline = null;
    };

    _this.handleTextChange = function (e) {
      var onChange = _this.props.onChange;

      var text = e.target.value;
      onChange ? onChange(e.target.value) : _this.setState({ text: text });
    };

    _this.handleSubmit = function () {
      _this.props.onSubmit(_this.props.text);
    };

    _this.handleClear = function () {
      var _this$props = _this.props,
          onSubmit = _this$props.onSubmit,
          onChange = _this$props.onChange;

      onChange ? onChange('') : _this.setState({ text: '' });
      onSubmit(null);
    };

    _this.handleKeyPress = function (e) {
      var _this$props2 = _this.props,
          text = _this$props2.text,
          onSubmit = _this$props2.onSubmit;

      if (e.key === 'Enter') onSubmit(text);
    };

    _this.onFocus = function (e) {
      e.target.parentNode.style.outline = '5px auto -webkit-focus-ring-color'; //#969599
    };

    _this.onBlur = function (e) {
      e.target.parentNode.style.outline = null;
    };

    _this.state = { text: '' };
    return _this;
  }

  _createClass(SearchBar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('click', this.onClickOutside, false);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.onClickOutside, false);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          placeholder = _props.placeholder,
          canClear = _props.canClear,
          style = _props.style;

      var text = this.props.text || this.state.text;
      var styles = (0, _lodash2.default)({}, SearchBar.defaultStyles, style);

      return _react2.default.createElement(
        'div',
        { ref: function ref(node) {
            return _this2.node = node;
          }, style: styles.base },
        _react2.default.createElement('input', {
          style: styles.input,
          value: text,
          type: 'text',
          placeholder: placeholder,
          onChange: this.handleTextChange,
          onKeyPress: this.handleKeyPress,
          onFocus: this.onFocus,
          onBlur: this.onBlur
        }),
        canClear && text && text.length > 0 ? _react2.default.createElement(
          'i',
          {
            className: 'material-icons',
            style: styles.clearIcon,
            onClick: this.handleClear },
          'clear'
        ) : null,
        _react2.default.createElement(
          'i',
          {
            className: 'material-icons',
            style: styles.submitIcon,
            onClick: this.handleSubmit },
          'search'
        )
      );
    }
  }]);

  return SearchBar;
}(_react2.default.Component);

SearchBar.propTypes = {
  placeholder: _propTypes2.default.string,
  text: _propTypes2.default.string,
  canClear: _propTypes2.default.bool,
  onChange: _propTypes2.default.func,
  onSubmit: _propTypes2.default.func.isRequired,
  style: _propTypes2.default.object
};
SearchBar.defaultProps = {
  placeholder: 'Search...',
  canClear: true,
  text: null,
  style: {}
};
SearchBar.defaultStyles = {
  base: {
    display: 'flex',
    alignItems: 'center',
    padding: '0 10px',
    border: '1px solid #EBE9ED',
    borderRadius: 2,
    height: 32,
    backgroundColor: '#ffffff',
    boxSizing: 'border-box'
  },
  input: {
    display: 'flex',
    borderRadius: 'inherit',
    fontSize: 16,
    fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif',
    border: 'none',
    width: '100%',
    height: '100%',
    outline: 0,
    backgroundColor: 'inherit',
    boxSizing: 'border-box'
  },
  submitIcon: {
    fontSize: 16,
    cursor: 'pointer'
  },
  clearIcon: {
    fontSize: 14,
    cursor: 'pointer',
    padding: 3,
    marginRight: 3
  }
};
exports.default = SearchBar;