'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = function (_React$Component) {
  _inherits(Select, _React$Component);

  function Select(props) {
    _classCallCheck(this, Select);

    var _this = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this, props));

    _this.handleSelect = function (e) {

      var value = e.target.value;

      if (value === '__placeholder') return _this.props.onChange(null);

      _this.props.onChange(value);
    };

    _this.renderPlaceholder = function () {
      var _this$props = _this.props,
          placeholder = _this$props.placeholder,
          isMultiple = _this$props.isMultiple;


      if (isMultiple) return;

      return _react2.default.createElement(
        'option',
        { value: '__placeholder' },
        placeholder
      );
    };

    _this.onFocus = function (e) {
      var onFocus = _this.props.onFocus;

      if (onFocus) onFocus(e);
      _this.setState({ isFocused: true });
    };

    _this.onBlur = function (e) {
      var onBlur = _this.props.onBlur;

      if (onBlur) onBlur(e);
      _this.setState({ isFocused: false });
    };

    _this.onMouseOver = function (e) {
      return _this.setState({ isHovered: true });
    };

    _this.onMouseLeave = function (e) {
      return _this.setState({ isHovered: false });
    };

    _this.state = {
      isFocused: false
    };
    return _this;
  }

  _createClass(Select, [{
    key: 'render',
    value: function render() {
      var _state = this.state,
          isFocused = _state.isFocused,
          isHovered = _state.isHovered;
      var _props = this.props,
          children = _props.children,
          defaultValue = _props.defaultValue,
          value = _props.value,
          isDisabled = _props.isDisabled,
          style = _props.style;


      var styles = (0, _lodash2.default)({}, Select.defaultStyles, style);

      if (isHovered) (0, _lodash2.default)(styles.base, styles.hovered);
      if (isFocused) (0, _lodash2.default)(styles.base, styles.focused);

      return _react2.default.createElement(
        'select',
        {
          style: styles.base,
          defaultValue: defaultValue,
          value: value,
          onFocus: this.onFocus,
          onBlur: this.onBlur,
          onMouseOver: this.onMouseOver,
          onMouseLeave: this.onMouseLeave,
          onChange: this.handleSelect,
          disabled: isDisabled
        },
        this.renderPlaceholder(),
        children
      );
    }
  }]);

  return Select;
}(_react2.default.Component);

Select.propTypes = {
  placeholder: _propTypes2.default.string,
  defaultValue: _propTypes2.default.string,
  value: _propTypes2.default.string,
  isDisabled: _propTypes2.default.bool,
  onChange: _propTypes2.default.func.isRequired,
  style: _propTypes2.default.object,
  children: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(function (propValue, key, componentName) {
    if (propValue[key].type.name !== 'SelectOption') return new Error('One or more children are not of type SelectOption');
  }), _propTypes2.default.objectOf(function (propValue, key) {
    if (propValue.type.name !== 'SelectOption') return new Error('One or more children are not of type SelectOption');
  })])
};
Select.defaultProps = {
  placeholder: 'Select an option...',
  isDisabled: false,
  style: {}
};
Select.defaultStyles = {
  base: {
    height: 44,
    width: '100%',
    paddingLeft: 5,
    fontSize: 16,
    fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif',
    textAlign: 'center',
    border: '1px solid',
    borderColor: '#979797',
    outline: 'none',
    borderRadius: 2,
    WebkitAppearance: null,
    backgroundColor: '#ffffff',
    transition: 'all 0.4s'
  },
  hovered: {},
  focused: {
    borderColor: '#09D8B7'
  },
  error: {
    borderColor: '#F25B5B'
  },
  disabled: {
    borderColor: '#b5b5b5',
    color: '#b5b5b5'
  }
};
exports.default = Select;