'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.get');

var _lodash4 = _interopRequireDefault(_lodash3);

var _styles = require('./utils/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tooltip = function (_React$Component) {
  _inherits(Tooltip, _React$Component);

  function Tooltip(props) {
    _classCallCheck(this, Tooltip);

    var _this = _possibleConstructorReturn(this, (Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).call(this, props));

    _this.onMouseOver = function () {
      _this.setState({ isHovered: true });
    };

    _this.onMouseLeave = function () {
      _this.setState({ isHovered: false });
    };

    _this.setStyles = function (style, position) {
      var _this$state = _this.state,
          isHovered = _this$state.isHovered,
          childWidth = _this$state.childWidth,
          tooltipWidth = _this$state.tooltipWidth,
          tooltipHeight = _this$state.tooltipHeight;


      var styles = (0, _lodash2.default)({}, Tooltip.defaultStyles, style);

      if (_this.childRef && _this.tooltipRef) {
        switch (position) {
          case 'top':
            var dif = tooltipWidth > childWidth ? -(tooltipWidth - childWidth) / 2 : (childWidth - tooltipWidth) / 2;
            (0, _lodash2.default)(styles.tooltip.base, { top: -tooltipHeight, left: dif });

        }
      }

      if (_this.childRef && _this.tooltipRef) {
        var _dif = tooltipWidth > childWidth ? -(tooltipWidth - childWidth) / 2 : (childWidth - tooltipWidth) / 2;
        (0, _lodash2.default)(styles.tooltip.base, { top: -tooltipHeight, left: _dif });
      }

      if (isHovered) (0, _lodash2.default)(styles.tooltip.base, styles.tooltip.hovered);

      return styles;
    };

    _this.state = {
      isHovered: false
    };
    return _this;
  }

  _createClass(Tooltip, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setState({
        childWidth: (0, _styles.getStyleValue)(this.childRef, 'width'),
        childHeight: (0, _styles.getStyleValue)(this.childRef, 'height'),
        tooltipWidth: (0, _styles.getStyleValue)(this.tooltipRef, 'width'),
        tooltipHeight: (0, _styles.getStyleValue)(this.tooltipRef, 'height')
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          text = _props.text,
          position = _props.position,
          children = _props.children,
          style = _props.style;

      // merge styles

      var styles = this.setStyles(style, position);

      return _react2.default.cloneElement(children, {
        ref: function ref(_ref) {
          return _this2.childRef = _ref;
        },
        onMouseOver: this.onMouseOver,
        onMouseLeave: this.onMouseLeave,
        style: (0, _lodash2.default)({}, children.props.style, { position: (0, _lodash4.default)(children, 'props.style.position', 'relative') }),
        children: [_react2.default.createElement(
          'div',
          { style: styles.container.base },
          _react2.default.createElement(
            'div',
            { ref: function ref(_ref2) {
                return _this2.tooltipRef = _ref2;
              }, style: styles.tooltip.base },
            _react2.default.createElement(
              'div',
              { style: styles.content.base },
              _react2.default.createElement(
                'p',
                { style: styles.text.base },
                text
              )
            ),
            _react2.default.createElement('div', { style: styles.triangle.base })
          )
        )].concat(_toConsumableArray(_react2.default.Children.toArray(children.props.children)))
      });
    }
  }, {
    key: 'width',
    get: function get() {
      if (!this.childRef && !this.tooltipRef) return null;

      return 0;
    }
  }, {
    key: 'height',
    get: function get() {
      if (!this.childRef) return null;
    }
  }]);

  return Tooltip;
}(_react2.default.Component);

Tooltip.propTypes = {
  text: _propTypes2.default.string,
  offset: _propTypes2.default.number,
  //delay: PropTypes.number,
  position: _propTypes2.default.oneOf(['top', 'right', 'bottom', 'left']),
  children: _propTypes2.default.element.isRequired
};
Tooltip.defaultProps = {
  text: '',
  offset: 0,
  //delay: 0,
  position: 'top'
};
Tooltip.defaultStyles = {
  container: {
    base: {
      position: 'absolute',
      display: 'inline-block',
      top: 0,
      left: 0,
      height: 0
    }
  },
  tooltip: {
    base: {
      display: 'flex',
      flexDirection: 'column',
      justifyContent: 'space-between',
      alignItems: 'center',
      position: 'absolute',
      flexShrink: 0,
      zIndex: 1000,
      //Transition Styles
      transition: 'opacity 0.5s',
      visibility: 'hidden',
      opacity: 0,
      maxWidth: 200
    },
    hovered: {
      opacity: 0.9,
      visibility: 'visible'
    }
  },
  content: {
    base: {
      display: 'inline-block',
      borderRadius: 2,
      padding: 10,
      boxSizing: 'border-box',
      backgroundColor: '#000000'
    }
  },
  text: {
    base: {
      display: 'flex',
      position: 'relative',
      whiteSpace: 'nowrap',
      margin: 0,
      padding: 0,
      fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif',
      textAlign: 'center',
      fontSize: 14,
      color: '#ffffff'
    }
  },
  triangle: {
    base: {
      width: 0,
      height: 0,
      top: 0,
      borderLeft: '10px solid transparent',
      borderRight: '10px solid transparent',
      borderTop: '10px solid #000000'
    }
  }
};
exports.default = Tooltip;