'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('babel-polyfill');

var _Calendar = require('./Calendar');

var _Calendar2 = _interopRequireDefault(_Calendar);

var _DateInput = require('./DateInput');

var _DateInput2 = _interopRequireDefault(_DateInput);

var _DatePicker = require('./DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _TimePicker = require('./TimePicker');

var _TimePicker2 = _interopRequireDefault(_TimePicker);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _lodash = require('lodash.isequal');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.merge');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DateTimePicker = function (_React$Component) {
  _inherits(DateTimePicker, _React$Component);

  function DateTimePicker(props) {
    _classCallCheck(this, DateTimePicker);

    var _this = _possibleConstructorReturn(this, (DateTimePicker.__proto__ || Object.getPrototypeOf(DateTimePicker)).call(this, props));

    _initialiseProps.call(_this);

    _this.state = {
      isCalendarVisible: false,
      startMonth: (0, _moment2.default)().utc().startOf('month'),
      endMonth: (0, _moment2.default)().utc().add(1, 'months').startOf('month')
    };
    return _this;
  }

  _createClass(DateTimePicker, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          startDate = _props.startDate,
          endDate = _props.endDate;

      this.setState({
        startDate: startDate ? startDate.utc() : null,
        endDate: endDate ? endDate.utc() : null,
        startMonth: startDate ? startDate.clone().utc().startOf('month') : this.state.startMonth,
        endMonth: endDate ? endDate.clone().utc().startOf('month') : this.state.endMonth
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('click', this.onClickOutside, false);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var startDate = nextProps.startDate,
          endDate = nextProps.endDate;


      this.setState({
        startDate: startDate ? startDate.utc() : null,
        endDate: endDate ? endDate.utc() : null,
        startMonth: startDate && !(0, _lodash2.default)(this.props.startDate, startDate) ? startDate.clone().utc().startOf('month') : this.state.startMonth,
        endMonth: endDate && !(0, _lodash2.default)(this.props.endDate, endDate) ? endDate.clone().utc().startOf('month') : this.state.endMonth
      });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var _state = this.state,
          startDate = _state.startDate,
          endDate = _state.endDate;
      var onChange = this.props.onChange;


      if (!(0, _lodash2.default)(prevState.startDate, startDate) || !(0, _lodash2.default)(prevState.endDate, endDate)) {

        onChange(startDate, endDate);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.onClickOutside, false);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state2 = this.state,
          startDate = _state2.startDate,
          endDate = _state2.endDate,
          isCalendarVisible = _state2.isCalendarVisible;
      var _props2 = this.props,
          dateFormat = _props2.dateFormat,
          timeFormat = _props2.timeFormat,
          isTimePicker = _props2.isTimePicker,
          placeholder = _props2.placeholder,
          pickerDirection = _props2.pickerDirection,
          canClear = _props2.canClear,
          style = _props2.style;


      var styles = (0, _lodash4.default)({}, DateTimePicker.defaultStyles, style);

      if (isCalendarVisible) (0, _lodash4.default)(styles.pickerContainer.base, styles.pickerContainer.isVisible);
      if (pickerDirection === 'left') (0, _lodash4.default)(styles.pickerContainer.base, styles.pickerContainer.left);
      if (pickerDirection === 'right') (0, _lodash4.default)(styles.pickerContainer.base, styles.pickerContainer.right);

      return _react2.default.createElement(
        'div',
        { ref: function ref(main) {
            return _this2.main = main;
          }, style: styles.base },
        _react2.default.createElement(_DateInput2.default, {
          canClear: canClear,
          startDate: startDate,
          endDate: endDate,
          startTime: startDate,
          endTime: endDate,
          dateFormat: dateFormat,
          timeFormat: timeFormat,
          isTimePicker: isTimePicker,
          placeholder: placeholder,
          onInputClick: this.handleInputClick,
          onClearClick: this.handleClearClick,
          style: styles.input
        }),
        this.renderDatePicker(styles)
      );
    }
  }]);

  return DateTimePicker;
}(_react2.default.Component);

DateTimePicker.propTypes = {
  isRangePicker: _propTypes2.default.bool,
  isTimePicker: _propTypes2.default.bool,
  canClear: _propTypes2.default.bool,
  dateFormat: _propTypes2.default.string,
  timeFormat: _propTypes2.default.string,
  startDate: function startDate(props, propName, componentName) {
    if (props[propName] && !_moment2.default.isMoment(props[propName])) {
      return new Error('Invalid prop `' + propName + '` supplied to' + ' `' + componentName + '`. Validation failed.');
    }
  },
  endDate: function endDate(props, propName, componentName) {
    if (props[propName] && !_moment2.default.isMoment(props[propName])) {
      return new Error('Invalid prop `' + propName + '` supplied to' + ' `' + componentName + '`. Validation failed.');
    }
  },
  placeholder: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  pickerDirection: _propTypes2.default.oneOf(['left', 'right']),
  style: _propTypes2.default.object
};
DateTimePicker.defaultProps = {
  isRangePicker: false,
  isTimePicker: false,
  canClear: true,
  dateFormat: 'MMM DD, YYYY',
  timeFormat: 'hh:mm a',
  placeholder: 'Select a Date',
  pickerDirection: 'left',
  style: {}
};
DateTimePicker.defaultStyles = {
  base: {
    position: 'relative',
    fontSize: 16,
    fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif',
    overflow: 'visible'
  },
  input: {},
  datePicker: {},
  timePicker: {},
  calendar: {},
  pickerContainer: {
    base: {
      overflow: 'visible',
      padding: 10,
      backgroundColor: 'white',
      display: 'flex',
      position: 'absolute',
      visibility: 'hidden',
      marginTop: 3,
      border: '1px solid #dcdcdc',
      borderRadius: 3,
      transition: '0.5s ease',
      opacity: 0,
      zIndex: 10000
    },
    isVisible: {
      visibility: 'visible',
      opacity: 1
    },
    right: {
      right: 0
    },
    left: {
      left: 0
    }
  },
  calendarContainer: {
    display: 'flex',
    flexDirection: 'column',
    justifyContent: 'space-between'
  },
  rangeDisplay: {
    padding: 10,
    fontSize: 14
  },
  verticalRule: {
    borderLeft: '1px solid #ccc',
    height: 'inherit',
    width: 2,
    margin: '0 10px'
  }
};

var _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.onClickOutside = function (e) {
    if (_this3.main && _this3.main.contains(e.target)) {
      return;
    }

    _this3.setState({ isCalendarVisible: false });
  };

  this.handleDatePickerStartChange = function (startMonth) {
    _this3.setState({ startMonth: startMonth });
  };

  this.handleDatePickerEndChange = function (endMonth) {
    _this3.setState({ endMonth: endMonth });
  };

  this.onStartDateChange = function (date) {
    var _state3 = _this3.state,
        startMonth = _state3.startMonth,
        startDate = _state3.startDate,
        endDate = _state3.endDate;

    date = date.clone();
    date = startDate ? date.hour(startDate.hour()).minute(startDate.minute()) : date;

    if (_this3.props.isRangePicker) {
      endDate = endDate && date.clone().startOf('day') > endDate.clone().startOf('day') ? null : endDate;
    }

    _this3.setState({
      startDate: date,
      startMonth: startMonth.month() !== date.month() ? date.clone() : startMonth.clone(),
      endDate: endDate
    });
  };

  this.onEndDateChange = function (date) {
    var _state4 = _this3.state,
        endMonth = _state4.endMonth,
        endDate = _state4.endDate,
        startDate = _state4.startDate;

    date = date.clone();
    date = endDate ? date.hour(endDate.hour()).minute(endDate.minute()) : date;

    if (_this3.props.isRangePicker) {
      startDate = startDate && date.clone().startOf('day') < startDate.clone().startOf('day') ? null : startDate;
    }

    _this3.setState({
      endDate: date,
      endMonth: endMonth.month() !== date.month() ? date.clone() : endMonth.clone(),
      startDate: startDate
    });
  };

  this.handleTimePickerStartChange = function (date) {
    _this3.setState({
      startDate: date
    });
  };

  this.handleTimePickerEndChange = function (date) {
    _this3.setState({
      endDate: date
    });
  };

  this.handleInputClick = function () {
    _this3.setState({ isCalendarVisible: !_this3.state.isCalendarVisible });
  };

  this.handleClearClick = function () {
    _this3.setState({
      startDate: null,
      startTime: null,
      endDate: null,
      endTime: null
    });
  };

  this.renderDatePicker = function (styles) {
    var _props3 = _this3.props,
        isRangePicker = _props3.isRangePicker,
        isTimePicker = _props3.isTimePicker,
        dateFormat = _props3.dateFormat;
    var _state5 = _this3.state,
        startMonth = _state5.startMonth,
        endMonth = _state5.endMonth,
        startDate = _state5.startDate,
        endDate = _state5.endDate;


    return _react2.default.createElement(
      'div',
      { style: styles.pickerContainer.base },
      _react2.default.createElement(
        'div',
        { style: styles.calendarContainer },
        isRangePicker ? _react2.default.createElement(
          'div',
          { style: styles.rangeDisplay },
          'Start Date: ',
          startDate ? startDate.format(dateFormat) : '--'
        ) : null,
        _react2.default.createElement(_DatePicker2.default, {
          month: startMonth,
          onChange: _this3.handleDatePickerStartChange,
          style: styles.datePicker
        }),
        _react2.default.createElement(_Calendar2.default, {
          isRangePicker: isRangePicker,
          selectedDate: startDate,
          rangeDate: endDate,
          calendarDate: startMonth,
          onDateChange: _this3.onStartDateChange,
          style: styles.calendar
        }),
        isTimePicker ? _react2.default.createElement(_TimePicker2.default, {
          date: startDate,
          onChange: _this3.handleTimePickerStartChange,
          style: styles.timePicker
        }) : null
      ),
      isRangePicker ? _react2.default.createElement('div', { style: styles.verticalRule }) : null,
      isRangePicker ? _react2.default.createElement(
        'div',
        { style: styles.calendarContainer },
        _react2.default.createElement(
          'div',
          null,
          isRangePicker ? _react2.default.createElement(
            'div',
            { style: styles.rangeDisplay },
            'End Date: ',
            endDate ? endDate.format(dateFormat) : '--'
          ) : null,
          _react2.default.createElement(_DatePicker2.default, {
            month: endMonth,
            onChange: _this3.handleDatePickerEndChange,
            styles: styles.datePicker
          }),
          _react2.default.createElement(_Calendar2.default, {
            isRangePicker: isRangePicker,
            selectedDate: endDate,
            rangeDate: startDate,
            calendarDate: endMonth,
            onDateChange: _this3.onEndDateChange,
            style: styles.calendar
          })
        ),
        isTimePicker ? _react2.default.createElement(_TimePicker2.default, {
          date: endDate,
          onChange: _this3.handleTimePickerEndChange,
          style: styles.timePicker
        }) : null
      ) : null
    );
  };
};

exports.default = DateTimePicker;