'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var List = function (_React$Component) {
  _inherits(List, _React$Component);

  function List(props) {
    _classCallCheck(this, List);

    var _this = _possibleConstructorReturn(this, (List.__proto__ || Object.getPrototypeOf(List)).call(this, props));

    _this.state = { height: 0 };
    return _this;
  }

  _createClass(List, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.element = this.ref ? _reactDom2.default.findDOMNode(this.ref) : null;
      var computedStyle = this.element ? window.getComputedStyle(this.element) : null;
      var height = computedStyle ? parseInt(computedStyle.height, 10) : 0;

      this.setState({ height: height });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var style = this.props.style;


      var styles = (0, _lodash2.default)({}, List.defaultStyles, style);

      var children = _react2.default.Children.toArray(this.props.children);

      var Toolbar = children.filter(function (child) {
        var isListToolbar = child.type.name === 'ListToolbar';
        var isFixed = child.props && child.props.type === 'fixed';
        return isListToolbar && isFixed;
      });

      var Cells = children.filter(function (child) {
        return child.type.name === 'ListCell';
      });
      var Menus = children.filter(function (child) {
        return child.type.name === 'ListMenu';
      }).map(function (child) {
        return _react2.default.cloneElement(child, { height: _this2.state.height });
      });

      return _react2.default.createElement(
        'div',
        { ref: function ref(_ref) {
            return _this2.ref = _ref;
          }, style: styles.base },
        _react2.default.createElement(
          'div',
          { style: styles.container },
          Menus,
          _react2.default.createElement(
            'div',
            { style: styles.fixedBar },
            Toolbar
          ),
          _react2.default.createElement(
            'div',
            { style: styles.cells },
            Cells
          )
        )
      );
    }
  }]);

  return List;
}(_react2.default.Component);

List.propTypes = {
  style: _propTypes2.default.object,
  children: _propTypes2.default.any
};
List.defaultProps = {
  style: { base: {}, cells: {} }
};
List.defaultStyles = {
  base: {
    width: '100%',
    height: '100%',
    boxSizing: 'border-box',
    boxShadow: '0 2px 2px 0 rgba(0,0,0,.14), 0 3px 1px -2px rgba(0,0,0,.2), 0 1px 5px 0 rgba(0,0,0,.12)'
  },
  container: {
    position: 'relative',
    display: 'flex',
    flexDirection: 'column',
    flexShrink: 0,
    width: '100%',
    height: '100%',
    boxSizing: 'border-box'
  },
  fixedBar: {},
  cells: {
    display: 'flex',
    flexDirection: 'column',
    boxSizing: 'border-box',
    overflowY: 'scroll',
    backgroundColor: 'white',
    width: '100%'
  }
};
exports.default = List;