'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AnimationTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AnimationTypes = exports.AnimationTypes = {
  ON: 'on',
  OFF: 'off',
  VISIBLE: 'visible',
  HIDDEN: 'hidden'
};

var ListAnimation = function (_React$Component) {
  _inherits(ListAnimation, _React$Component);

  function ListAnimation() {
    _classCallCheck(this, ListAnimation);

    return _possibleConstructorReturn(this, (ListAnimation.__proto__ || Object.getPrototypeOf(ListAnimation)).apply(this, arguments));
  }

  _createClass(ListAnimation, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.element = this.ref ? _reactDom2.default.findDOMNode(this.ref) : null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          duration = _props.duration,
          animation = _props.animation,
          style = _props.style,
          children = _props.children;


      var computedStyle = this.element ? window.getComputedStyle(this.element) : null;
      var width = computedStyle ? parseInt(computedStyle.width, 10) : 0;

      var styles = (0, _lodash2.default)({}, ListAnimation.defaultStyles, style);
      (0, _lodash2.default)(styles.slide.base, { transition: 'all ' + duration + 'ms' });
      (0, _lodash2.default)(styles.slide.off, { left: width });
      (0, _lodash2.default)(styles.slide.hidden, { left: width });
      (0, _lodash2.default)(styles.slide.base, styles.slide[animation]);

      return _react2.default.cloneElement(children, {
        ref: function ref(_ref) {
          return _this2.ref = _ref;
        },
        style: _extends({}, children.props.style, styles.slide, {
          boxShadow: null
        })
      });
    }
  }]);

  return ListAnimation;
}(_react2.default.Component);

ListAnimation.propTypes = {
  animation: _propTypes2.default.oneOf([].concat(_toConsumableArray(Object.values(AnimationTypes)))),
  children: _propTypes2.default.element.isRequired,
  duration: _propTypes2.default.number
};
ListAnimation.defaultProps = {
  animation: AnimationTypes.HIDDEN,
  duration: 500,
  shouldRender: true
};
ListAnimation.defaultStyles = {
  base: {
    position: 'absolute',
    width: '100%',
    height: '100%',
    top: 0,
    left: 0,
    overflow: 'hidden'
  },
  slide: {
    base: {
      width: '100%',
      height: '100%',
      left: 0,
      position: 'absolute',
      transition: 'all 500ms'
    },
    on: { visibility: 'visible', left: 0 },
    off: { visibility: 'visible', left: '' },
    visible: { visibility: 'visible', left: 0, transition: null },
    hidden: { visibility: 'hidden', left: '', transition: null }
  }
};
exports.default = ListAnimation;