'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _styles = require('../utils/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListCell = function (_React$Component) {
  _inherits(ListCell, _React$Component);

  function ListCell() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ListCell);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ListCell.__proto__ || Object.getPrototypeOf(ListCell)).call.apply(_ref, [this].concat(args))), _this), _this.state = { isHovered: false }, _this.handleClick = function () {
      var onClick = _this.props.onClick;

      if (onClick) onClick();
    }, _this.onMouseOver = function () {
      _this.setState({ isHovered: true });
    }, _this.onMouseLeave = function () {
      _this.setState({ isHovered: false });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ListCell, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          style = _props.style,
          isActive = _props.isActive,
          isDisabled = _props.isDisabled;
      var isHovered = this.state.isHovered;


      var styles = (0, _lodash2.default)({}, ListCell.defaultStyles, style);
      var events = { isActive: isActive, isDisabled: isDisabled, isHovered: isHovered };
      (0, _styles.mergeEvents)(styles, events);

      return _react2.default.createElement(
        'div',
        {
          style: styles.base,
          onClick: this.handleClick,
          onMouseLeave: this.onMouseLeave,
          onMouseOver: this.onMouseOver
        },
        children
      );
    }
  }]);

  return ListCell;
}(_react2.default.Component);

ListCell.propTypes = {
  onClick: _propTypes2.default.func,
  style: _propTypes2.default.object,
  isActive: _propTypes2.default.bool,
  isDisabled: _propTypes2.default.bool
};
ListCell.defaultProps = {
  isSelected: false
};
ListCell.defaultStyles = {
  base: {
    borderBottom: '1px solid #ccc',
    backgroundColor: '#fff',
    flexShrink: 0
  },
  hovered: {
    backgroundColor: '#BDBDBD',
    cursor: 'pointer'
  },
  active: {
    backgroundColor: '#BDBDBD'
  },
  disabled: {
    cursor: 'default'
  }
};
exports.default = ListCell;