'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ListAnimation = require('./ListAnimation');

var _ListAnimation2 = _interopRequireDefault(_ListAnimation);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListGroup = function (_React$Component) {
  _inherits(ListGroup, _React$Component);

  function ListGroup(props) {
    _classCallCheck(this, ListGroup);

    var _this = _possibleConstructorReturn(this, (ListGroup.__proto__ || Object.getPrototypeOf(ListGroup)).call(this, props));

    _this.getAnimation = function (i) {
      var prev = _this.state.prevIndex;
      var selected = _this.props.selectedIndex;
      var next = selected + 1;

      if (i === selected && prev === undefined) return _ListAnimation.AnimationTypes.ON;

      if (i === selected && i > prev) return _ListAnimation.AnimationTypes.ON;
      if (i === selected && i < prev) return _ListAnimation.AnimationTypes.VISIBLE;
      if (i === next) return _ListAnimation.AnimationTypes.OFF;

      if (i === prev && i < selected) return _ListAnimation.AnimationTypes.VISIBLE;
      return _ListAnimation.AnimationTypes.HIDDEN;
    };

    _this.state = { prevIndex: undefined };
    return _this;
  }

  _createClass(ListGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {

      if (this.props.selectedIndex !== nextProps.selectedIndex) {
        this.setState({
          prevIndex: this.props.selectedIndex
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          style = _props.style;

      var styles = (0, _lodash2.default)({}, ListGroup.defaultStyles, style);

      return _react2.default.createElement(
        'div',
        { style: styles.base },
        _react2.default.createElement(
          'div',
          { style: styles.container },
          _react2.default.Children.toArray(children).map(function (child, i) {
            return _react2.default.createElement(
              _ListAnimation2.default,
              {
                key: i,
                animation: _this2.getAnimation(i)
              },
              child
            );
          })
        )
      );
    }
  }]);

  return ListGroup;
}(_react2.default.Component);

ListGroup.propTypes = {
  selectedIndex: _propTypes2.default.number,
  children: _propTypes2.default.any
};
ListGroup.defaultProps = {
  selectedIndex: 0
};
ListGroup.defaultStyles = {
  base: {
    position: 'relative',
    width: '100%',
    height: '100%',
    overflow: 'hidden'
  },
  container: {
    display: 'flex',
    position: 'absolute',
    width: '100%',
    height: '100%',
    overflow: 'hidden',
    boxShadow: '0 2px 2px 0 rgba(0,0,0,.14), 0 3px 1px -2px rgba(0,0,0,.2), 0 1px 5px 0 rgba(0,0,0,.12)'
  }
};
exports.default = ListGroup;