'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListMenu = function (_React$Component) {
  _inherits(ListMenu, _React$Component);

  function ListMenu() {
    _classCallCheck(this, ListMenu);

    return _possibleConstructorReturn(this, (ListMenu.__proto__ || Object.getPrototypeOf(ListMenu)).apply(this, arguments));
  }

  _createClass(ListMenu, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.element = this.ref ? _reactDom2.default.findDOMNode(this.ref) : null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          style = _props.style,
          isVisible = _props.isVisible,
          animationTime = _props.animationTime,
          height = _props.height;


      var styles = (0, _lodash2.default)({}, ListMenu.defaultStyles, style);
      (0, _lodash2.default)(styles.base, {
        transition: 'all ' + animationTime + 'ms',
        top: height,
        height: height
      });

      if (isVisible) (0, _lodash2.default)(styles.base, styles.isVisible);

      var childArray = _react2.default.Children.toArray(children);
      var fixedToolbar = childArray.filter(function (child) {
        return child.type.name === 'ListToolbar';
      });
      var content = childArray.filter(function (child) {
        return child.type.name !== 'ListToolbar';
      });

      return _react2.default.createElement(
        'div',
        { ref: function ref(_ref) {
            return _this2.ref = _ref;
          }, style: styles.base },
        _react2.default.createElement(
          'div',
          { style: styles.container },
          _react2.default.createElement(
            'div',
            { style: styles.fixedBar },
            fixedToolbar
          ),
          _react2.default.createElement(
            'div',
            { style: styles.content },
            content
          )
        )
      );
    }
  }]);

  return ListMenu;
}(_react2.default.Component);

ListMenu.propTypes = {
  isVisible: _propTypes2.default.bool,
  animationTime: _propTypes2.default.number
};
ListMenu.defaultProps = {
  isVisible: false,
  animationTime: 300
};
ListMenu.defaultStyles = {
  base: {
    position: 'absolute',
    flexShrink: 0,
    width: '100%',
    height: '',
    boxSizing: 'border-box',
    zIndex: 1,
    // Transition Styles
    visibility: 'hidden',
    top: '',
    transition: 'all 300ms'
  },
  isVisible: {
    display: null,
    visibility: 'visible',
    top: 0
  },
  container: {
    position: 'relative',
    display: 'flex',
    flexDirection: 'column',
    flexShrink: 0,
    width: '100%',
    height: '100%',
    boxSizing: 'border-box'
  },
  content: {
    backgroundColor: 'white',
    display: 'flex',
    flexDirection: 'column',
    boxSizing: 'border-box',
    overflowY: 'scroll',
    width: '100%',
    height: '100%'
  }
};
exports.default = ListMenu;