'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ListToolbar = function ListToolbar(_ref) {
  var type = _ref.type,
      children = _ref.children,
      style = _ref.style;


  var styles = (0, _lodash2.default)({}, ListToolbar.defaultStyles, style);

  return _react2.default.createElement(
    'div',
    { style: styles.base },
    children
  );
};

ListToolbar.propTypes = {
  type: _propTypes2.default.string
};

ListToolbar.defaultStyles = {
  base: {
    display: 'flex',
    flexShrink: 0,
    position: 'relative',
    width: '100%',
    maxWidth: 'inherit',
    boxSizing: 'border-box',
    backgroundColor: '#616161',
    color: '#fff',
    alignItems: 'center',
    transition: 'transform 0.3s ease-out',
    boxShadow: '0 2px 0 0 rgba(0, 0, 0, 0.26)',
    padding: '0 16px',
    height: 64
  }
};

exports.default = ListToolbar;