'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DragIcon = function DragIcon(_ref) {
  var isDraggable = _ref.isDraggable,
      onDragStart = _ref.onDragStart,
      style = _ref.style;

  var styles = (0, _lodash2.default)({}, DragIcon.defaultStyles, style);

  return isDraggable ? _react2.default.createElement(
    'span',
    { style: styles.base },
    _react2.default.createElement(
      'i',
      {
        className: 'material-icons',
        draggable: isDraggable,
        onDragStart: onDragStart,
        style: styles.icon
      },
      'drag_handle'
    )
  ) : null;
};

DragIcon.propTypes = {
  isDraggable: _propTypes2.default.bool,
  style: _propTypes2.default.object
};

DragIcon.defaultProps = {
  isDraggable: false,
  style: {}
};

DragIcon.defaultStyles = {
  base: {
    color: '#d3d3d3',
    paddingLeft: 5,
    cursor: 'move'
  },
  icon: {}
};

exports.default = DragIcon;