'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _styles = require('../utils/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Icon = function Icon(_ref) {
  var isSortable = _ref.isSortable,
      sort = _ref.sort,
      order = _ref.order,
      style = _ref.style,
      _key = _ref._key;


  var styles = (0, _lodash2.default)({}, Icon.defaultStyles, style);
  var isSorted = sort === _key;

  (0, _styles.mergeEvents)(styles.asc, { isActive: order === 'asc' && isSorted });
  (0, _styles.mergeEvents)(styles.desc, { isActive: order === 'desc' && isSorted });

  var Ascending = function Ascending() {
    return _react2.default.createElement(
      'i',
      { className: 'material-icons', style: styles.asc.base },
      'arrow_drop_up'
    );
  };
  var Descending = function Descending() {
    return _react2.default.createElement(
      'i',
      { className: 'material-icons', style: styles.desc.base },
      'arrow_drop_down'
    );
  };

  return isSortable ? _react2.default.createElement(
    'div',
    { style: styles.base },
    _react2.default.createElement(Ascending, null),
    _react2.default.createElement(Descending, null)
  ) : null;
};

Icon.propTypes = {
  isSortable: _propTypes2.default.bool,
  sort: _propTypes2.default.string,
  order: _propTypes2.default.string,
  style: _propTypes2.default.object
};

Icon.defaultStyles = {
  base: {
    display: 'inline-flex',
    flexDirection: 'column',
    paddingLeft: 5
  },
  asc: {
    base: {
      color: '#d3d3d3',
      margin: -5
    },
    active: {
      color: '#000000'
    }
  },
  desc: {
    base: {
      color: '#d3d3d3',
      margin: -5
    },
    active: {
      color: '#000000'
    }
  }
};

exports.default = Icon;