'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.get');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.isstring');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.isobject');

var _lodash8 = _interopRequireDefault(_lodash7);

var _lodash9 = require('lodash.isequal');

var _lodash10 = _interopRequireDefault(_lodash9);

var _Thead = require('./Thead');

var _Thead2 = _interopRequireDefault(_Thead);

var _Tbody = require('./Tbody');

var _Tbody2 = _interopRequireDefault(_Tbody);

var _Th = require('./Th');

var _Th2 = _interopRequireDefault(_Th);

var _Tr = require('./Tr');

var _Tr2 = _interopRequireDefault(_Tr);

var _Td = require('./Td');

var _Td2 = _interopRequireDefault(_Td);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Table = function (_React$Component) {
  _inherits(Table, _React$Component);

  function Table(props) {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _this._configureColumns = function (columnConfig) {

      if (!columnConfig) return Object.keys(_this.props.data[0]).map(function (col) {
        return {
          key: col,
          _key: col,
          heading: col
        };
      });

      return columnConfig.map(function (col) {
        return _extends({}, (0, _lodash8.default)(col) ? col : null, {
          key: col.key || col,
          _key: col.key || col,
          heading: col.heading || col.key || col
        });
      });
    };

    _this._configureData = function () {
      var data = _this.props.data;

      // if sort and order specified externally, return data

      var isExternal = _this.props.sort || _this.props.order;
      if (isExternal) return data;

      // otherwise return sorted if specified
      var sort = _this.state.sort.key;
      var order = _this.state.sort.order;

      //perform the sort
      return sort && order ? data.sort(function (a, b) {
        return order === 'asc' ? a[sort] > b[sort] : b[sort] > a[sort];
      }) : data;
    };

    _this.onRowClick = function (row, index) {
      var onRowClick = _this.props.onRowClick;

      if (onRowClick) onRowClick(row, index);
    };

    _this.onDragStart = function (key, e) {
      _this.setState({ dragStart: key });
    };

    _this.onDragOver = function (key, e) {
      if (_this.state.dragOver === key) return;

      var col = _this.props.columnConfig.find(function (col) {
        return col === key || col.key === key;
      });

      _this.setState({ dragOver: (0, _lodash4.default)(col, 'isDraggable', key) });
    };

    _this.onDrop = function (key, e) {
      var _this$state = _this.state,
          dragStart = _this$state.dragStart,
          dragOver = _this$state.dragOver;

      var column = _this.state.columns.find(function (col) {
        return col.key === dragStart;
      });
      var filtered = _this.state.columns.filter(function (col) {
        return col.key !== dragStart;
      });
      var index = filtered.findIndex(function (col) {
        return col.key === dragOver;
      });

      var columns = index < 0 ? _this.state.columns : [].concat(_toConsumableArray(filtered.slice(0, index)), [column], _toConsumableArray(filtered.slice(index, filtered.length)));

      _this.setState({
        dragStart: null,
        dragOver: null,
        columns: columns
      });
    };

    _this.onSort = function (key) {
      var onSort = _this.props.onSort;

      var sort = _this.props.sort || _this.state.sort.key;
      var order = _this.props.order || _this.state.sort.order;

      // set sort and order
      if (sort !== key || !order) order = 'asc';else order = order === 'asc' ? 'desc' : 'asc';

      //emit onSort if present
      if (onSort) onSort(key, order);
      _this.setState({ sort: { key: key, order: order } });
    };

    _this.renderHeading = function (column, columnIndex, style) {
      var dragOver = _this.state.dragOver;
      var sortIcons = _this.props.sortIcons;

      var sort = _this.state.sort.key;
      var order = _this.state.sort.order;
      var isDragOver = column.key === dragOver;
      var isDraggable = column.isDraggable != undefined ? column.isDraggable : _this.props.isDraggable;
      var isSortable = column.isSortable != undefined ? column.isSortable : _this.props.isSortable;

      // configure styles
      var styles = isDragOver ? { base: _extends({}, style.base, style.dragOver) } : style;

      // return custom heading if present
      if (column.renderHeading) {

        var element = column.renderHeading(column.heading, columnIndex, column);
        var elementStyles = (0, _lodash4.default)(element, 'props.style', {});

        return _react2.default.cloneElement(element, _extends({}, column, element.props, {
          key: column.key,
          heading: element.props.heading,
          sortIcons: column.sortIcons || sortIcons,
          onClick: column.onClick || _this.onSort,
          sort: sort,
          order: order,
          isDraggable: isDraggable,
          isSortable: isSortable,
          onDragStart: _this.onDragStart,
          onDragOver: _this.onDragOver,
          onDrop: _this.onDrop,
          style: _extends({}, elementStyles, {
            base: _extends({}, elementStyles.base, styles.base)
          })
        }));
      }

      // return default heading
      return _react2.default.createElement(_Th2.default, _extends({}, column, {
        key: column.key,
        style: styles,
        onClick: _this.onSort,
        sortIcons: column.sortIcons || sortIcons,
        sort: sort,
        order: order,
        isDraggable: isDraggable,
        onDragStart: _this.onDragStart,
        onDragOver: _this.onDragOver,
        onDrop: _this.onDrop
      }));
    };

    _this.renderCell = function (data, column, rowIndex, style) {
      var dragOver = _this.state.dragOver;

      var isDragOver = column.key === dragOver;

      // set computedValue if present
      var value = column.computedValue ? column.computedValue(data[column.key], rowIndex, data) : data[column.key];

      // configure styles
      var styles = isDragOver ? { base: _extends({}, style.base, style.dragOver) } : style;

      // return custom cell if present
      if (column.renderCell) {

        var col = column.renderCell(value, rowIndex, data, column);
        var elementStyles = (0, _lodash4.default)(col, 'props.style', {});

        return _react2.default.cloneElement(col, {
          key: column.key,
          style: _extends({}, elementStyles, {
            base: _extends({}, elementStyles.base, styles.base)
          })
        });
      }

      // return default cell
      return _react2.default.createElement(_Td2.default, {
        key: column.key,
        value: value,
        style: styles
      });
    };

    _this.state = {
      sort: {
        key: null,
        order: null
      },
      dragStart: null,
      dragOver: null
    };
    return _this;
  }

  _createClass(Table, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          sort = _props.sort,
          order = _props.order,
          columnConfig = _props.columnConfig;

      this.setState({
        sort: { key: sort, order: order },
        columns: this._configureColumns(columnConfig)
      });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {

      var prevConfig = this.props.columnConfig.map(function (item) {
        return item.key || item;
      });
      var nextConfig = nextProps.columnConfig.map(function (item) {
        return item.key || item;
      });
      var configChanged = !(0, _lodash10.default)(prevConfig, nextConfig);

      if (configChanged) {
        this.setState({
          columns: this._configureColumns(nextProps.columnConfig)
        });
      }

      if (!(0, _lodash10.default)(this.props.sort, nextProps.sort) || !(0, _lodash10.default)(this.props.order, nextProps.order)) {
        this.setState({
          sort: {
            key: nextProps.sort,
            order: nextProps.order
          }
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          style = _props2.style,
          isSecondaryLayout = _props2.isSecondaryLayout,
          secondaryLayout = _props2.secondaryLayout;

      var columns = this.state.columns;
      var data = this._configureData();

      var styles = (0, _lodash2.default)({}, Table.defaultStyles, style

      // if(isSecondaryLayout){
      //   return !secondaryLayout
      //     ? <SecondaryTemplate columns={ columns } data={ data }/>
      //     : (<div>
      //         { data.map((d, rowIndex) => secondaryLayout(d, rowIndex)) }
      //       </div>)
      // }

      );return _react2.default.createElement(
        'div',
        { style: styles.table.base, role: 'table' },
        _react2.default.createElement(
          _Thead2.default,
          { style: styles.thead },
          _react2.default.createElement(
            _Tr2.default,
            { style: styles.tr, isHoverable: false },
            columns.map(function (col, columnIndex) {
              return _this2.renderHeading(col, columnIndex, styles.th);
            })
          )
        ),
        _react2.default.createElement(
          _Tbody2.default,
          { style: styles.tbody },
          data.map(function (d, rowIndex) {
            return _react2.default.createElement(
              _Tr2.default,
              {
                key: rowIndex,
                rowIndex: rowIndex,
                onClick: function onClick() {
                  return _this2.onRowClick(d, rowIndex);
                },
                style: styles.tr
              },
              columns.map(function (col) {
                return _this2.renderCell(d, col, rowIndex, styles.td);
              })
            );
          })
        )
      );
    }
  }]);

  return Table;
}(_react2.default.Component);

Table.propTypes = {
  data: _propTypes2.default.array,
  style: _propTypes2.default.object,
  columnConfig: _propTypes2.default.arrayOf(function (propValue, key, componentName, location, propFullName) {
    var isObject = !Array.isArray(propValue[key]) && _typeof(propValue[key]) === 'object';

    if (!isObject && !(0, _lodash6.default)(propValue[key])) {
      return new Error('Invalid prop ' + propFullName + ' supplied to ' + componentName + '. Array must contain Objects or Strings.');
    }

    if (isObject && !propValue[key].key) return new Error('Invalid prop ' + propFullName + ' supplied to ' + componentName + '. Objects must contain the property "key".');
  }),
  onSort: _propTypes2.default.func,
  filter: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  isStriped: _propTypes2.default.bool,
  isDraggable: _propTypes2.default.bool
};
Table.defaultProps = {
  data: [],
  style: {},
  isStriped: false,
  isDraggable: false
};
Table.defaultStyles = {
  table: {
    base: {
      width: '100%',
      display: 'table',
      borderCollapse: 'collapse'
    }
  },
  td: {
    base: {},
    dragOver: { borderLeft: '2px solid black' }
  },
  th: {
    base: {},
    dragOver: { borderLeft: '2px solid black' }
  }
};
exports.default = Table;


var SecondaryTemplate = function SecondaryTemplate(_ref) {
  var row = _ref.row,
      rowIndex = _ref.rowIndex,
      columns = _ref.columns;

  return _react2.default.createElement(
    'div',
    null,
    columns.map(function (col) {
      return _react2.default.createElement(
        'div',
        { key: col.key || col },
        col.heading,
        row[col.key || col]
      );
    })
  );
};