'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _string = require('../utils/string');

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.isstring');

var _lodash4 = _interopRequireDefault(_lodash3);

var _styles = require('../utils/styles');

var _SortIcon = require('./SortIcon');

var _SortIcon2 = _interopRequireDefault(_SortIcon);

var _DragIcon = require('./DragIcon');

var _DragIcon2 = _interopRequireDefault(_DragIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//TODO: KNOW ISSUE - Th wont refresh under certain circumstances in the column config

var Th = function Th(_ref) {
  var _key = _ref._key,
      isDraggable = _ref.isDraggable,
      heading = _ref.heading,
      sort = _ref.sort,
      order = _ref.order,
      onClick = _ref.onClick,
      onDragStart = _ref.onDragStart,
      onDragOver = _ref.onDragOver,
      onDrop = _ref.onDrop,
      isSortable = _ref.isSortable,
      style = _ref.style;


  var handleSort = function handleSort() {
    onClick(_key);
  };

  var handleDragStart = function handleDragStart(e) {
    onDragStart(_key, e);
  };

  var handleDragOver = function handleDragOver(e) {
    e.preventDefault();
    onDragOver(_key, e);
  };

  var handleDrop = function handleDrop(e) {
    e.preventDefault();
    onDrop(_key, e);
  };

  var styles = (0, _lodash2.default)({}, Th.defaultStyles, style);
  (0, _styles.mergeEvents)(styles.heading, { isHovered: isSortable });

  return _react2.default.createElement(
    'div',
    {
      role: 'columnheader',
      style: styles.base,
      onDragOver: handleDragOver,
      onDragEnd: handleDrop
    },
    _react2.default.createElement(
      'div',
      { style: styles.container },
      _react2.default.createElement(
        'span',
        { style: styles.heading.base, onClick: isSortable ? handleSort : null },
        _react2.default.createElement(
          'span',
          null,
          (0, _lodash4.default)(heading) ? (0, _string.camelToUpperCase)(heading) : heading
        ),
        _react2.default.createElement(_SortIcon2.default, {
          isSortable: isSortable,
          _key: _key,
          sort: sort,
          order: order
        })
      ),
      _react2.default.createElement(_DragIcon2.default, {
        isDraggable: isDraggable,
        onDragStart: handleDragStart
      })
    )
  );
};

Th.propTypes = {
  isDraggable: _propTypes2.default.bool,
  isSortable: _propTypes2.default.bool,
  heading: _propTypes2.default.any,
  sortIcons: _propTypes2.default.arrayOf(_propTypes2.default.element),
  sort: _propTypes2.default.string,
  order: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  onDragStart: _propTypes2.default.func,
  onDragOver: _propTypes2.default.func,
  onDrop: _propTypes2.default.func,
  style: _propTypes2.default.object
};

Th.defaultProps = {
  style: {},
  onDragStart: function onDragStart() {},
  onDragOver: function onDragOver() {},
  onDrop: function onDrop() {},
  isSortable: true,
  isDraggable: false
};

Th.defaultStyles = {
  base: {
    display: 'table-cell',
    padding: 10,
    fontSize: 16,
    fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif',
    fontWeight: 'bold',
    boxSizing: 'border-box',
    whiteSpace: 'nowrap',
    verticalAlign: 'center',
    borderLeft: '1px solid #d3d3d3',
    borderRight: '1px solid #d3d3d3',
    borderBottom: '1px solid #d3d3d3'
  },
  container: {
    display: 'flex',
    flexWrap: 'none',
    justifyContent: 'space-between',
    alignItems: 'center'
  },
  heading: {
    base: {},
    hovered: {
      cursor: 'pointer'
    }
  }
};

exports.default = Th;