'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _styles = require('../utils/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tr = function (_React$Component) {
  _inherits(Tr, _React$Component);

  function Tr() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Tr);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Tr.__proto__ || Object.getPrototypeOf(Tr)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isHovered: false,
      isActive: false
    }, _this.onMouseOver = function () {
      if (!_this.props.isHoverable) return;
      _this.setState({ isHovered: true });
    }, _this.onMouseLeave = function () {
      if (!_this.props.isHoverable) return;
      _this.setState({ isHovered: false });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Tr, [{
    key: 'isStriped',
    value: function isStriped(rowIndex) {
      if (rowIndex == null) return;
      return rowIndex === 0 || !(rowIndex & 1);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          rowIndex = _props.rowIndex,
          style = _props.style,
          children = _props.children;
      var _state = this.state,
          isHovered = _state.isHovered,
          isActive = _state.isActive;


      var styles = {
        base: {
          display: 'table-row',
          borderTop: '1px solid #d3d3d3'
        },
        striped: {
          backgroundColor: '#f4f4f4'
        },
        hovered: {
          backgroundColor: '#e1e1e1'
        },
        active: {
          backgroundColor: '#ffff00'
        }
      };

      (0, _lodash2.default)(styles, style);

      if (this.isStriped(rowIndex)) (0, _lodash2.default)(styles.base, styles.striped);

      (0, _styles.mergeEvents)(styles, { isHovered: isHovered, isActive: isActive });

      return _react2.default.createElement(
        'div',
        {
          role: 'row',
          style: styles.base,
          onMouseOver: this.onMouseOver,
          onMouseLeave: this.onMouseLeave
        },
        children
      );
    }
  }]);

  return Tr;
}(_react2.default.Component);

Tr.propTypes = {
  style: _propTypes2.default.object,
  isHoverable: _propTypes2.default.bool
};
Tr.defaultProps = {
  style: {},
  isHoverable: true
};
exports.default = Tr;