'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.get');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TextFieldExtension = function TextFieldExtension(_ref) {
  var extension = _ref.extension,
      appendExtension = _ref.appendExtension,
      style = _ref.style;

  if (!extension) return null;

  // get extension type
  var type = (0, _lodash4.default)(extension, 'type.name'

  // return string
  );if (typeof extension === 'string') return _react2.default.createElement(
    'div',
    { style: style.base },
    extension
  );

  // return Reactables Button
  if (type === 'Button') return _react2.default.cloneElement(extension, {
    style: (0, _lodash2.default)(extension.props.style, {
      base: _extends({}, style[appendExtension])
    })
  }

  // return Reactables Dropdown
  );if (type === 'Dropdown') {
    return _react2.default.cloneElement(extension, {
      children: extension.props.children.map(function (child) {
        return _react2.default.cloneElement(child, {
          style: (0, _lodash4.default)(child, 'type.name') === 'DropdownNode' ? (0, _lodash2.default)(child.props.style, {
            base: _extends({}, style[appendExtension])
          }) : child.props.style
        });
      })
    });
  }

  // return default
  return extension;
};

TextFieldExtension.propTypes = {
  extension: _propTypes2.default.any,
  style: _propTypes2.default.object
};
exports.default = TextFieldExtension;