'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextFieldInput = function (_React$Component) {
  _inherits(TextFieldInput, _React$Component);

  function TextFieldInput(props) {
    _classCallCheck(this, TextFieldInput);

    var _this = _possibleConstructorReturn(this, (TextFieldInput.__proto__ || Object.getPrototypeOf(TextFieldInput)).call(this, props));

    _this.componentWillReceiveProps = function (nextProps, nextState) {
      var value = _this.props.value || _this.state.value;
      var nextValue = nextProps.value || nextState.value;

      if (nextProps.validateOnChange && value !== nextValue) {
        var validation = _this.validate(nextValue);
        _this.setState(_extends({}, validation));
      }
    };

    _this.setInitialCursorPosition = function () {
      if (!_this.ref) return;
      _this.ref.selectionStart = _this.props.initialCursorPosition;
      _this.ref.selectionEnd = _this.props.initialCursorPosition;
    };

    _this.onChange = function (e) {
      var _this$props = _this.props,
          value = _this$props.value,
          onChange = _this$props.onChange;


      var eventValue = e.target.value || '';
      onChange(eventValue, e);

      var nextState = {};

      if (_this.state.wasVisited) {
        var validation = _this.validate(eventValue);

        switch (_this.state.isValid) {
          case null:
            nextState = validation.isValid ? validation : {};
            break;
          case true:
            nextState = validation.isValid === false ? validation : {};
            break;
          case false:
            nextState = validation;
            break;
        }
      }

      _this.setState(_extends({
        value: value === undefined ? eventValue : ''
      }, nextState));
    };

    _this.onFocus = function (e) {
      var onFocus = _this.props.onFocus;

      if (onFocus) onFocus(e);
      _this.setState({ isFocused: true });
    };

    _this.onBlur = function (e) {
      var onBlur = _this.props.onBlur;

      var value = e.target.value;

      if (onBlur) onBlur(e);
      var nextState = _this.validate(value);

      _this.setState(_extends({
        isFocused: false,
        wasVisited: true
      }, nextState));
    };

    _this.onMouseOver = function () {
      return _this.setState({ isHovered: true });
    };

    _this.onMouseLeave = function () {
      return _this.setState({ isHovered: false });
    };

    _this.onKeyPress = function (e) {
      _this.onTabKey(e);
      _this.onEnterKey(e);
    };

    _this.onTabKey = function (e) {
      if (!_this.props.shouldAllowTab || e.key !== 'Tab') return;
      e.preventDefault();
      var start = _this.ref.selectionStart;
      _this.ref.value = _this.ref.value.substring(0, _this.ref.selectionStart) + "\t" + _this.ref.value.substring(_this.ref.selectionEnd);
      _this.ref.selectionStart = start + 1;
      _this.ref.selectionEnd = start + 1;
    };

    _this.onEnterKey = function (e) {
      if (e.key !== 'Enter') return;

      var onEnterKey = _this.props.onEnterKey;

      var value = e.target.value;
      var nextState = _this.validate(value);

      if (onEnterKey && nextState.isValid !== false) onEnterKey(value, e);

      _this.setState(_extends({}, nextState, { wasVisited: true }));
    };

    _this.onClearClick = function (e) {
      e.target.value = '';
      _this.props.onClear('', e);
      _this.onChange(e);

      if (_this.props.value === undefined) _this.setState({ value: '' });
    };

    _this.validate = function (value) {
      var validators = _this.props.validators;
      if (!validators) return { isValid: true };

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = validators[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var v = _step.value;

          var validator = v.rule(value) ? null : v;
          if (validator) return { isValid: false, errorMessage: v.errorMessage };
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return { isValid: true, errorMessage: '' };
    };

    _this.state = {
      isHovered: false,
      isFocused: false,
      isValid: null,
      errorMessage: '',
      wasVisited: false,
      value: ''
    };
    return _this;
  }

  _createClass(TextFieldInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var value = this.props.value || this.state.value;
      this.setInitialCursorPosition();

      if (this.props.validateOnMount && value) {
        var validation = this.validate(value);
        this.setState(_extends({}, validation));
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          isDisabled = _props.isDisabled,
          style = _props.style;
      var _state = this.state,
          isFocused = _state.isFocused,
          isHovered = _state.isHovered,
          isValid = _state.isValid;

      var value = this.props.value || this.state.value;

      var styles = (0, _lodash2.default)({}, TextFieldInput.defaultStyles, style

      //event state
      );if (isHovered) (0, _lodash2.default)(styles.input.base, styles.input.hovered);
      if (isFocused) (0, _lodash2.default)(styles.input.base, styles.input.focused);
      if (isValid === false) (0, _lodash2.default)(styles.input.base, styles.input.error);
      if (isDisabled) (0, _lodash2.default)(styles.input.base, styles.input.disabled);

      return _react2.default.createElement(
        'span',
        {
          style: styles.inputContainer.base,
          onMouseOver: this.onMouseOver,
          onMouseLeave: this.onMouseLeave
        },
        _react2.default.createElement(LeftIcon, {
          leftIcon: this.props.leftIcon,
          element: this.props.element,
          style: styles.leftIcon
        }),
        _react2.default.createElement(this.props.element, {
          type: 'text',
          ref: function ref(_ref) {
            return _this2.ref = _ref;
          },
          id: this.props.id,
          role: this.props.role,
          tabIndex: this.props.tabIndex,
          placeholder: this.props.placeholder,
          name: this.props.name,
          value: value,
          onFocus: this.onFocus,
          onBlur: this.onBlur,
          onChange: this.onChange,
          onKeyDown: this.onKeyPress,
          disabled: this.props.isDisabled,
          autoFocus: this.props.autoFocus,
          style: styles.input.base
        }),
        _react2.default.createElement(ClearIcon, {
          value: value,
          element: this.props.element,
          canClear: this.props.canClear,
          clearIcon: this.props.clearIcon,
          onClear: this.onClearClick,
          style: styles.clearIcon
        }),
        _react2.default.createElement(ErrorMessage, {
          text: this.state.errorMessage,
          style: styles.errorMessage
        })
      );
    }
  }]);

  return TextFieldInput;
}(_react2.default.Component);

TextFieldInput.propTypes = {
  placeholder: _propTypes2.default.string,
  name: _propTypes2.default.string,
  role: _propTypes2.default.string,
  tabIndex: _propTypes2.default.number,
  id: _propTypes2.default.string,
  element: _propTypes2.default.oneOf(['input', 'textarea']),
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  validators: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    name: _propTypes2.default.string,
    rule: _propTypes2.default.func.isRequired,
    errorMessage: _propTypes2.default.string
  })),
  isDisabled: _propTypes2.default.bool,
  autoFocus: _propTypes2.default.bool,
  canClear: _propTypes2.default.bool,
  leftIcon: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.element]),
  clearIcon: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.element]),
  extension: _propTypes2.default.any,
  appendExtension: _propTypes2.default.oneOf(['left', 'right']),
  onClear: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  onBlur: _propTypes2.default.func,
  onEnterKey: _propTypes2.default.func,
  validateOnChange: _propTypes2.default.bool,
  validateOnMount: _propTypes2.default.bool,
  initialCursorPosition: _propTypes2.default.number,
  shouldAllowTab: _propTypes2.default.bool
};
TextFieldInput.defaultProps = {
  element: 'input',
  role: 'textbox',
  appendExtension: 'right',
  isDisabled: false,
  value: undefined,
  onClear: function onClear() {},
  onChange: function onChange() {},
  validateOnChange: false,
  validateOnMount: false
};
TextFieldInput.defaultStyles = {};
exports.default = TextFieldInput;


var ErrorMessage = function ErrorMessage(_ref2) {
  var text = _ref2.text,
      style = _ref2.style;

  return _react2.default.createElement(
    'p',
    { style: style.base },
    text
  );
};

var LeftIcon = function LeftIcon(_ref3) {
  var leftIcon = _ref3.leftIcon,
      style = _ref3.style;

  if (!leftIcon) return null;

  if (typeof leftIcon !== 'boolean') return _react2.default.cloneElement(leftIcon, {
    style: (0, _lodash2.default)({}, style.base, leftIcon.props.style)
  });

  return _react2.default.createElement(
    'i',
    { className: 'material-icons', style: style.base },
    'search'
  );
};

var ClearIcon = function ClearIcon(_ref4) {
  var canClear = _ref4.canClear,
      onClear = _ref4.onClear,
      clearIcon = _ref4.clearIcon,
      value = _ref4.value,
      style = _ref4.style;

  if (!canClear || !value || !value.length) return null;

  return clearIcon ? _react2.default.cloneElement(clearIcon, { style: (0, _lodash2.default)({}, style.base, clearIcon.props.style) }) : _react2.default.createElement(
    'i',
    { className: 'material-icons', style: style.base, onClick: onClear },
    'clear'
  );
};