'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cloneWithStyles = exports.getComputedStyleProp = exports.getStyleValue = exports.mergeEvents = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _reactDom = require('react-dom');

var _lodash = require('lodash.get');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.merge');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mergeEvents = exports.mergeEvents = function mergeEvents(styles, events) {
  var isDisabled = events.isDisabled,
      isActive = events.isActive,
      isHovered = events.isHovered,
      isComplete = events.isComplete;


  if (isDisabled) return (0, _lodash4.default)(styles.base, styles.disabled);else if (isActive) return (0, _lodash4.default)(styles.base, styles.active);else if (isComplete) return (0, _lodash4.default)(styles.base, styles.complete);else if (isHovered) return (0, _lodash4.default)(styles.base, styles.hovered);
};

var getStyleValue = exports.getStyleValue = function getStyleValue(element, prop) {
  // if React element
  if ((0, _react.isValidElement)(element)) {
    element = (0, _reactDom.findDOMNode)(element);
  }
  var value = (0, _lodash2.default)(element, 'style.' + prop);
  return value && value.indexOf('%') <= -1 ? parseInt(value) : parseInt(window.getComputedStyle(element)[prop], 10);
};

var getComputedStyleProp = exports.getComputedStyleProp = function getComputedStyleProp(element, propString, defaultValue) {
  if (typeof propString !== 'string') console.error('getComputedStyleProp prop arg must be a string');

  if (!element) return defaultValue;

  var prop = (0, _lodash2.default)(element, 'props.style.' + propString, window.getComputedStyle((0, _reactDom.findDOMNode)(element))[propString] || defaultValue);

  var computedProp = prop.indexOf('%') >= 0 ? window.getComputedStyle((0, _reactDom.findDOMNode)(element))[prop] : prop;

  return computedProp.indexOf('px') >= 0 ? parseInt(computedProp, 10) : computedProp;
};

var cloneWithStyles = exports.cloneWithStyles = function cloneWithStyles(element) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  var styles = args.reduce(function (obj, style) {
    return _extends({}, obj, style);
  }, {});

  return (0, _react.cloneElement)(element, {
    style: _extends({}, element.props.style, styles)
  });
};