'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _WizardTimeline = require('./WizardTimeline');

var _WizardTimeline2 = _interopRequireDefault(_WizardTimeline);

var _WizardTimelineStep = require('./WizardTimelineStep');

var _WizardTimelineStep2 = _interopRequireDefault(_WizardTimelineStep);

var _WizardContent = require('./WizardContent');

var _WizardContent2 = _interopRequireDefault(_WizardContent);

var _WizardControls = require('./WizardControls');

var _WizardControls2 = _interopRequireDefault(_WizardControls);

var _lodash3 = require('lodash.isequal');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wizard = function (_React$Component) {
  _inherits(Wizard, _React$Component);

  function Wizard(props) {
    _classCallCheck(this, Wizard);

    var _this = _possibleConstructorReturn(this, (Wizard.__proto__ || Object.getPrototypeOf(Wizard)).call(this, props));

    _this.validateSteps = function () {
      var validation = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      _this.setState({ isNextActive: validation.every(function (item) {
          return item;
        }) });
    };

    _this.handleTimelineClick = function (selectedIndex, selectedName) {
      var currentIndex = _this.state.selectedIndex;

      //check validators if jumping forward
      if (selectedIndex > currentIndex) {

        //get all the step names and slice the range
        var names = _this.props.children.map(function (child) {
          return child.props.name;
        }).slice(currentIndex, selectedIndex

        //check each validator - return if not valid
        );var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = names[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var name = _step.value;

            var validators = _this.props.validation[name] || [];
            if (!validators.every(function (v) {
              return v;
            })) return;
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }

      _this.setState({ selectedIndex: selectedIndex, selectedName: selectedName });
    };

    _this.handlePreviousClick = function () {
      //don't allow a back click if you're on the 1st page
      var selectedIndex = _this.state.selectedIndex - 1;
      if (selectedIndex < 0) return;

      _this.props.onPrevious(_this.state.selectedIndex, selectedIndex);

      _this.setState({
        selectedIndex: selectedIndex,
        selectedName: _this.props.children[selectedIndex].props.name
      });
    };

    _this.handleNextClick = function () {
      // don't allow a Next click if selected is greater than
      // the number of Steps or Next button is inactive
      var selectedIndex = _this.state.selectedIndex + 1;
      if (selectedIndex >= _this.props.children.length || !_this.state.isNextActive) return;

      _this.props.onNext(_this.state.selectedIndex, selectedIndex);

      _this.setState({
        selectedIndex: selectedIndex,
        selectedName: _this.props.children[selectedIndex].props.name
      });
    };

    _this.state = {
      isNextActive: false,
      selectedIndex: 0,
      selectedName: ''
    };
    return _this;
  }

  _createClass(Wizard, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var children = this.props.children;

      // if children are present, grab the 1st child and set it's name as selectedName in state

      this.setState({
        selectedName: children ? _react2.default.Children.toArray(children)[0].props.name : ''
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var selectedName = this.state.selectedName;

      // preform validation as soon as the component is mounted

      var validation = this.props.validation[selectedName];
      this.validateSteps(validation);
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      var selectedName = this.state.selectedName;

      var validation = this.props.validation[selectedName];
      var nextValidation = nextProps.validation[nextState.selectedName];

      //and time the validators are updated, run the validation steps again
      if (!(0, _lodash4.default)(validation, nextValidation)) {
        this.validateSteps(nextValidation);
      }
    }

    // Validation Handler for the current step

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          menuOffset = _props.menuOffset,
          style = _props.style;

      // clone styles

      var styles = (0, _lodash2.default)({}, Wizard.defaultStyles, style

      // clone all children with a key - React requirement
      );var children = _react2.default.Children.toArray(this.props.children).map(function (child) {
        return _react2.default.cloneElement(child, {
          key: child.props.name
        });
      });

      return _react2.default.createElement(
        'div',
        { style: styles.base },
        this.props.shouldShowTimeline ? _react2.default.createElement(
          _WizardTimeline2.default,
          { selectedIndex: this.state.selectedIndex, style: styles.timeline },
          children.map(function (child, i) {
            return _react2.default.createElement(_WizardTimelineStep2.default, {
              key: i,
              index: i,
              onClick: _this2.handleTimelineClick,
              name: child.props.name,
              title: child.props.title,
              selectedIndex: _this2.state.selectedIndex,
              steps: children.length,
              style: styles.timelineStep
            });
          })
        ) : null,
        _react2.default.createElement(
          'div',
          { style: styles.container.base },
          _react2.default.createElement(
            _WizardContent2.default,
            { style: styles.content, selectedIndex: this.state.selectedIndex },
            children
          ),
          _react2.default.createElement(_WizardControls2.default, {
            style: styles.controls,
            menu: this.props.menu,
            tools: this.props.tools,
            menuOffset: menuOffset,
            isNextActive: this.state.isNextActive,
            nextText: this.props.nextText,
            previousText: this.props.previousText,
            menuText: this.props.menuText,
            completeText: this.props.completeText,
            nextClick: this.handleNextClick,
            previousClick: this.handlePreviousClick,
            completeClick: this.props.onComplete,
            steps: children.length,
            selectedIndex: this.state.selectedIndex
          })
        )
      );
    }
  }]);

  return Wizard;
}(_react2.default.Component);

Wizard.propTypes = {
  children: _propTypes2.default.any,
  menu: _propTypes2.default.array,
  tools: _propTypes2.default.array,
  menuOffset: _propTypes2.default.number,
  style: _propTypes2.default.object,
  previousText: _propTypes2.default.string,
  nextText: _propTypes2.default.string,
  menuText: _propTypes2.default.string,
  completeText: _propTypes2.default.string,
  validation: _propTypes2.default.object,
  onComplete: _propTypes2.default.func,
  onNext: _propTypes2.default.func,
  onPrevious: _propTypes2.default.func,
  shouldShowTimeline: _propTypes2.default.bool
};
Wizard.defaultProps = {
  style: {},
  previousText: 'Previous',
  nextText: 'Next',
  menuText: 'Menu',
  completeText: 'Complete',
  onComplete: function onComplete() {},
  onNext: function onNext() {},
  onPrevious: function onPrevious() {},
  menuOffset: 0,
  validation: {},
  menu: [],
  tools: [],
  shouldShowTimeline: true
};
Wizard.defaultStyles = {
  base: {
    display: 'flex',
    flexDirection: 'column',
    backgroundColor: 'white',
    width: '100%'
  },
  container: {
    base: {
      display: 'flex',
      flexDirection: 'column',
      justifyContent: 'space-between',
      width: '100%',
      height: '100%'
    }
  },
  content: { base: {} },
  toolbar: { base: {} },
  timeline: { base: {} },
  timelineStep: { base: {} },
  controls: { base: {} }
};
exports.default = Wizard;