'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _WizardAnimation = require('./WizardAnimation');

var _WizardAnimation2 = _interopRequireDefault(_WizardAnimation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WizardContent = function (_React$Component) {
  _inherits(WizardContent, _React$Component);

  function WizardContent(props) {
    _classCallCheck(this, WizardContent);

    var _this = _possibleConstructorReturn(this, (WizardContent.__proto__ || Object.getPrototypeOf(WizardContent)).call(this, props));

    _this.getAnimation = function (i) {
      var prev = _this.state.prevIndex;
      var selected = _this.props.selectedIndex;
      var next = selected + 1;

      // animation rules
      if (i === selected && prev === undefined) return _WizardAnimation.AnimationTypes.ON;
      if (i === selected && i > prev) return _WizardAnimation.AnimationTypes.ON;
      if (i === selected && i < prev) return _WizardAnimation.AnimationTypes.VISIBLE;
      if (i === next) return _WizardAnimation.AnimationTypes.OFF;
      if (i === prev && i < selected) return _WizardAnimation.AnimationTypes.VISIBLE;

      //default to hidden
      return _WizardAnimation.AnimationTypes.HIDDEN;
    };

    _this.state = { prevIndex: undefined };
    return _this;
  }

  _createClass(WizardContent, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {

      if (this.props.selectedIndex !== nextProps.selectedIndex) {
        this.setState({
          prevIndex: this.props.selectedIndex
        });
      }
    }

    // orchestrator to determine animation prop for WizardAnimation

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var style = this.props.style;

      var children = _react2.default.Children.toArray(this.props.children

      //merge styles
      );var styles = (0, _lodash2.default)({}, WizardContent.defaultStyles, style);

      return _react2.default.createElement(
        'div',
        { style: styles.base },
        _react2.default.createElement(
          'div',
          { style: styles.container },
          children.map(function (child, i) {
            return _react2.default.createElement(
              _WizardAnimation2.default,
              {
                key: child.props.name,
                animation: _this2.getAnimation(i)
              },
              child
            );
          })
        )
      );
    }
  }]);

  return WizardContent;
}(_react2.default.Component);

WizardContent.propTypes = {
  children: _propTypes2.default.any,
  style: _propTypes2.default.object,
  selectedIndex: _propTypes2.default.number
};
WizardContent.defaultProps = {
  selectedIndex: 0,
  style: {}
};
WizardContent.defaultStyles = {
  base: {
    position: 'relative',
    width: '100%',
    height: '100%',
    overflow: 'hidden'
  },
  container: {
    display: 'flex',
    position: 'absolute',
    width: '100%',
    height: '100%',
    overflow: 'hidden'
  }
};
exports.default = WizardContent;