'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Dropdown = require('../Dropdown');

var _Dropdown2 = _interopRequireDefault(_Dropdown);

var _DropdownNode = require('../DropdownNode');

var _DropdownNode2 = _interopRequireDefault(_DropdownNode);

var _DropdownMenu = require('../DropdownMenu');

var _DropdownMenu2 = _interopRequireDefault(_DropdownMenu);

var _DropdownOption = require('../DropdownOption');

var _DropdownOption2 = _interopRequireDefault(_DropdownOption);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WizardControls = function (_React$Component) {
  _inherits(WizardControls, _React$Component);

  function WizardControls() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, WizardControls);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WizardControls.__proto__ || Object.getPrototypeOf(WizardControls)).call.apply(_ref, [this].concat(args))), _this), _this.previousClick = function () {
      _this.props.previousClick();
    }, _this.nextClick = function () {
      _this.props.nextClick();
    }, _this.completeClick = function () {
      _this.props.completeClick();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(WizardControls, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          style = _props.style,
          tools = _props.tools,
          menuOffset = _props.menuOffset,
          nextText = _props.nextText,
          previousText = _props.previousText,
          completeText = _props.completeText,
          isNextActive = _props.isNextActive,
          isPreviousDisabled = _props.isPreviousDisabled,
          steps = _props.steps,
          selectedIndex = _props.selectedIndex;

      var styles = (0, _lodash2.default)({}, WizardControls.defaultStyles, style

      //next button styles
      );var nextButtonStyles = (0, _lodash2.default)({}, styles.button, styles.button.next);
      var completeButtonStyles = (0, _lodash2.default)({}, styles.button, styles.button.complete);

      if (isNextActive) (0, _lodash2.default)(nextButtonStyles.base, nextButtonStyles.active);
      if (isNextActive) (0, _lodash2.default)(completeButtonStyles.base, completeButtonStyles.active);

      return _react2.default.createElement(
        'div',
        { style: styles.base },
        _react2.default.createElement(
          'div',
          { style: styles.container },
          this.props.menu.length ? _react2.default.createElement(
            _Dropdown2.default,
            null,
            _react2.default.createElement(
              _DropdownNode2.default,
              { style: styles.button },
              this.props.menuText,
              '  ',
              _react2.default.createElement(
                'i',
                { className: 'material-icons' },
                'keyboard_arrow_up'
              )
            ),
            _react2.default.createElement(
              _DropdownMenu2.default,
              {
                drop: 'up',
                offset: menuOffset,
                style: styles.dropdownMenu
              },
              this.props.menu.map(function (item, i) {
                return _react2.default.createElement(_DropdownOption2.default, {
                  key: i,
                  text: item.props.text,
                  isDisabled: item.props.isDisabled,
                  isActive: item.props.isActive,
                  onClick: item.props.onClick,
                  style: item.props.style });
              })
            )
          ) : null,
          tools.length ? tools.map(function (tool, i) {
            return _react2.default.cloneElement(tool, { key: i });
          }) : null
        ),
        _react2.default.createElement(
          'div',
          { style: styles.container },
          _react2.default.createElement(_Button2.default, {
            style: styles.button,
            text: previousText,
            onClick: this.previousClick,
            isDisabled: isPreviousDisabled
          }),
          steps === selectedIndex + 1 ? _react2.default.createElement(_Button2.default, {
            style: completeButtonStyles,
            text: completeText,
            onClick: this.completeClick
          }) : _react2.default.createElement(_Button2.default, {
            style: nextButtonStyles,
            text: _react2.default.createElement(
              'span',
              { style: styles.nextText },
              nextText,
              _react2.default.createElement(
                'i',
                { className: 'material-icons', style: styles.nextIcon },
                'keyboard_arrow_right'
              )
            ),
            onClick: this.nextClick, isDisabled: !isNextActive })
        )
      );
    }
  }]);

  return WizardControls;
}(_react2.default.Component);

WizardControls.propTypes = {
  children: _propTypes2.default.any,
  style: _propTypes2.default.object,
  isNextActive: _propTypes2.default.bool,
  nextText: _propTypes2.default.string,
  previousText: _propTypes2.default.string,
  completeText: _propTypes2.default.string,
  nextClick: _propTypes2.default.func.isRequired,
  previousClick: _propTypes2.default.func.isRequired,
  menuText: _propTypes2.default.string,
  menu: _propTypes2.default.array,
  menuOffset: _propTypes2.default.number,
  selectedIndex: _propTypes2.default.number,
  steps: _propTypes2.default.number
};
WizardControls.defaultProps = {
  style: {},
  isNextActive: false,
  menu: [],
  menuOffset: 0,
  steps: 0,
  selectedIndex: 0
};
WizardControls.defaultStyles = {
  base: {
    display: 'flex',
    justifyContent: 'space-between',
    height: 50,
    backgroundColor: '#636363'
  },
  container: {
    display: 'flex',
    alignItems: 'center'
  },
  button: {
    base: {
      borderRadius: 0,
      margin: 0,
      height: '100%',
      width: 100,
      backgroundColor: '#707070',
      color: 'white'
    },
    disabled: {
      backgroundColor: '#6B6A6A'
    },
    hovered: {
      backgroundColor: '#7D7D7D'
    },
    next: {
      active: {
        backgroundColor: '#2DE594'
      },
      hovered: {
        backgroundColor: '#5EF0B0'
      }
    },
    complete: {
      active: {
        backgroundColor: '#1E88E5'
      },
      hovered: {
        backgroundColor: '#2196F3'
      }
    }
  },
  nextText: {
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    width: '100%'
  },
  nextIcon: { padding: 0, margin: 0 },
  dropdownMenu: {
    base: {
      border: '1px solid rgb(220, 220, 220)',
      borderRadius: 0,
      boxShadow: '-2px 10px 30px -15px rgba(0,0,0,0.10)'
    },
    left: { left: 5 }
  }
};
exports.default = WizardControls;