'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WizardTimeline = function (_React$Component) {
  _inherits(WizardTimeline, _React$Component);

  function WizardTimeline() {
    _classCallCheck(this, WizardTimeline);

    return _possibleConstructorReturn(this, (WizardTimeline.__proto__ || Object.getPrototypeOf(WizardTimeline)).apply(this, arguments));
  }

  _createClass(WizardTimeline, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          selectedIndex = _props.selectedIndex,
          style = _props.style,
          children = _props.children;

      //merge styles

      var styles = (0, _lodash2.default)({}, WizardTimeline.defaultStyles, style

      //iterate over the children, add a "Connector" line
      );var steps = _react2.default.Children.toArray(children).reduce(function (timeline, child, i) {
        return [].concat(_toConsumableArray(timeline), [child, _react2.default.createElement(Connector, {
          key: 'connector_' + i,
          stepCount: children.length,
          step: i + 1,
          isComplete: i < selectedIndex,
          isActive: i === selectedIndex
        })]);
      }, []);

      return _react2.default.createElement(
        'div',
        { style: (0, _lodash2.default)({}, styles.base, steps.length > 1 ? { justifyContent: 'center' } : null) },
        steps
      );
    }
  }]);

  return WizardTimeline;
}(_react2.default.Component);

/**
 * Connector component
 */

WizardTimeline.propTypes = {
  children: _propTypes2.default.any,
  style: _propTypes2.default.object,
  selectedIndex: _propTypes2.default.number
};
WizardTimeline.defaultProps = {
  style: {},
  selectedIndex: 0
};
WizardTimeline.defaultStyles = {
  base: {
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'space-between',
    margin: 0,
    padding: '50px 50px 30px 50px',
    minHeight: 50,
    width: '100%',
    boxSizing: 'border-box',
    boxShadow: '-1px 1px 30px 0px rgba(0,0,0,0.10)',
    zIndex: 10
  }
};
exports.default = WizardTimeline;
var Connector = function Connector(_ref) {
  var isComplete = _ref.isComplete,
      stepCount = _ref.stepCount,
      step = _ref.step;


  //if the step is the LAST step, return null
  if (step >= stepCount) return null;

  return _react2.default.createElement('div', { style: {
      height: 2,
      background: 'linear-gradient(to right, #2de594 50%, #c0c0c0 50%)',
      backgroundSize: '200% 100%',
      backgroundPosition: isComplete ? 'left bottom' : 'right bottom',
      flexGrow: 1,
      transition: 'all 500ms ease'
    } });
};