'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _styles = require('../utils/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WizardTimelineStep = function (_React$Component) {
  _inherits(WizardTimelineStep, _React$Component);

  function WizardTimelineStep() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, WizardTimelineStep);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WizardTimelineStep.__proto__ || Object.getPrototypeOf(WizardTimelineStep)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function () {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          name = _this$props.name,
          index = _this$props.index;

      if (onClick) onClick(index, name);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(WizardTimelineStep, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          selectedIndex = _props.selectedIndex,
          index = _props.index,
          steps = _props.steps,
          title = _props.title,
          style = _props.style;

      var styles = (0, _lodash2.default)({}, WizardTimelineStep.defaultStyles, style

      //determine step presentational state for mergeEvents
      );var isActive = index === selectedIndex;
      var isComplete = index < selectedIndex;
      var isFinal = selectedIndex === index && index + 1 === steps;

      (0, _styles.mergeEvents)(styles, { isActive: isActive, isComplete: isComplete });
      if (isFinal) (0, _lodash2.default)(styles.base, styles.final

      // material icons
      );var RADIO_BUTTON_CHECKED = 'radio_button_checked';
      var RADIO_BUTTON_UNCHECKED = 'radio_button_unchecked';

      return _react2.default.createElement(
        'div',
        { style: styles.base, onClick: this.onClick },
        _react2.default.createElement(
          'p',
          { style: styles.title },
          title
        ),
        _react2.default.createElement(
          'i',
          { className: 'material-icons' },
          isComplete ? RADIO_BUTTON_CHECKED : isActive ? RADIO_BUTTON_CHECKED : RADIO_BUTTON_UNCHECKED
        )
      );
    }
  }]);

  return WizardTimelineStep;
}(_react2.default.Component);

WizardTimelineStep.propTypes = {
  children: _propTypes2.default.any,
  style: _propTypes2.default.object,
  onClick: _propTypes2.default.func,
  isValid: _propTypes2.default.bool
};
WizardTimelineStep.defaultProps = {
  style: {},
  isValid: false
};
WizardTimelineStep.defaultStyles = {
  base: {
    position: 'relative',
    display: 'flex',
    flexGrow: 0,
    flexShrink: 0,
    flexDirection: 'column',
    justifyContent: 'center',
    alignItems: 'center',
    backgroundColor: 'inherit',
    margin: 0,
    padding: 0,
    fontSize: 12,
    whiteSpace: 'nowrap',
    fontFamily: 'Helvetica Neue, Helvetica, Arial, sans-serif',
    transition: 'all 500ms ease',
    cursor: 'default',
    color: '#C0C0C0'
  },
  complete: {
    color: '#2DE594'
  },
  active: {
    color: 'black'
  },
  final: {
    color: '#1E88E5'
  },
  title: {
    position: 'absolute',
    padding: 0,
    margin: 0,
    top: -20
  },
  icon: {}
};
exports.default = WizardTimelineStep;